<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


// no direct access
defined('_JEXEC') or die('Restricted access');


class PhotoSpotDisplayItem {
	var $title = false;
	var $description = false;
	var $link = false;
	var $img_url = false;
	var $img_abs = false;
	var $img_width = false;
	var $img_height = false;
	var $thumb_abs = false;
	var $thumb_url = false;
	var $thumb_width = false;
	var $thumb_height = false;
	var $mtime = false;
	var $ext = false;
	var $mime = false;
	var $info = array();

	function get_title() {
		if ($this->title !== false)
			return $this->title;
		else
			return basename($this->img_url);
	}

	function get_thumb_size($req_width, $req_height, &$url, &$width, &$height) {
		if ($this->thumb_url !== false) {
			$url = $this->thumb_url;
			$width = (int) $this->thumb_width;
			$height = (int) $this->thumb_height;
		}
		else {
			$url = $this->img_url;
			$width = (int) $this->img_width;
			$height = (int) $this->img_height;
		}

		$ratio = $height == 0 ? 0 : $width / $height;

		if ($req_width > 0 && $req_height > 0) {
			if ($width == 0 || $height == 0) {
				$width = $req_width;
				$height = $req_height;
			}
			else if ($width > $req_width || $height > $req_height) {
				$height = $req_height;
				$width = $height * $ratio;

				if ($width > $req_width) {
					$width = $req_width;
					$height = round($width / $ratio);
				}
			}
		}
		else if ($req_width > 0 && $width > $req_width) {
			$width = $req_width;
			$height = round($width / $ratio);
		}
		else if ($req_height > 0 && $height > $req_height) {
			$height = $req_height;
			$width = $height * $ratio;
		}
	}

}

class PhotoSpotDatasourceDisplay {
	var $gallery_name = '';
	var $menu_params = false;
	var $params = false;
	var $img_url_path = false;
	var $img_abs_path = false;
	var $thumb_url_path = false;
	var $thumb_abs_path = false;
	var $items = array();
	var $items_count = 0;

	function init() {
		// subclass this function
	}

}

class PhotoSpotViewerDisplay {
	var $limit = 0;
	var $limitstart = 0;
	var $params = false;
	var $process_datasource = true;

	function enable_lightbox() {
		static $enabled = false;
		if (!$enabled) {
			$document =& JFactory::getDocument();
			$document->addScript('administrator/components/com_photospot/js/jquery-1.3.2.min.js');
			$document->addScript('administrator/components/com_photospot/js/slimbox2.js');
		}
	}

	function init() {
		// subclass this function
	}

	function render() {
		// subclass this function
	}

}

?>