<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceBannersAdmin extends PhotoSpotDatasourceAdmin {

	function setup() {
		$this->data_set('direct_link', '1');
		$this->save();
	}

	function edit() {
		$load_data = true;

		$warnings = array();

		if ($this->get('hfrm_datasource_edit', '') != '') {
			$load_data = false;
			$v_catid = trim($this->get('catid', ''));
			$v_direct_link = trim($this->get('direct_link', '0'));

			$v_order = trim($this->get('order', ''));

			if ($this->page_refreshed) {
				// ignore page refreshes
			}
			else if ($this->get('btn_cancel', '') != '') {
				// form cancelled
				$load_data = true;
			}
			else {
				// form submitted successfully

				$utils =& PhotoSpotUtils::get_instance();

				$error_msg = '';

				if ($v_catid != '' && !ctype_digit($v_catid))
					$error_msg = JText::_('The value in the Category ID field is not a valid number');

				if ($error_msg == '') {
					$this->data_set('catid', $v_catid);
					$this->data_set('direct_link', $v_direct_link);
					$this->data_set('order', $v_order);
					$this->save();

					global $mainframe;
					$mainframe->enqueueMessage(JText::_('Datasource updated successfully'));
				}
				else {
					JError::raiseWarning($error_msg, $error_msg);
				}
			}
		}

		if ($load_data) {
			$v_filter = $this->data_get('catid', '');
			$v_direct_link = $this->data_get('direct_link', '');
			$v_order = $this->data_get('order', '');
		}

		$v_direct_link = (bool) $v_direct_link;

		echo '
<form name="frm_datasource" method="post" action="index.php">
	<input type="hidden" name="hfrm_datasource_edit" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="' . htmlspecialchars(JRequest::getCmd('id')) . '" />

	<input type="submit" name="dmsub" style="display:none" />

	<table cellspacing="10">
		<tr>
			<td valign="top">' . JText::_('Category ID') . '</td>
			<td><input type="text" name="catid" value="' . htmlspecialchars($v_catid) . '" /></td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Link type') . '</td>
			<td>
				<input type="radio" name="direct_link" value="0"' . ($v_direct_link ? '' : ' checked="checked"') . ' /> ' . JText::_('Tracked link') . '
				&nbsp; <input type="radio" name="direct_link" value="1"' . ($v_direct_link ? ' checked="checked"' : '') . ' /> ' . JText::_('Direct link') . '
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Order by') . '</td>
			<td>
				<select name="order">
					<option value="sticky_order"' . ($v_order == 'sticky_order' ? ' selected="selected"' : '') . '>' . JText::_('Sticky, Default order') . '</option>
					<option value="sticky_date_desc"' . ($v_order == 'sticky_date_desc' ? ' selected="selected"' : '') . '>' . JText::_('Sticky, Date - Newer first') . '</option>
					<option value="sticky_date_asc"' . ($v_order == 'sticky_date_asc' ? ' selected="selected"' : '') . '>' . JText::_('Sticky, Date - Older first') . '</option>
					<option value="sticky_name"' . ($v_order == 'sticky_name' ? ' selected="selected"' : '') . '>' . JText::_('Sticky, Name') . '</option>
					<option value="sticky_random"' . ($v_order == 'sticky_random' ? ' selected="selected"' : '') . '>' . JText::_('Sticky, Random') . '</option>
					<option value="order"' . ($v_order == 'order' ? ' selected="selected"' : '') . '>' . JText::_('Default order') . '</option>
					<option value="date_desc"' . ($v_order == 'date_desc' ? ' selected="selected"' : '') . '>' . JText::_('Date - Newer first') . '</option>
					<option value="date_asc"' . ($v_order == 'date_asc' ? ' selected="selected"' : '') . '>' . JText::_('Date - Older first') . '</option>
					<option value="name"' . ($v_order == 'name' ? ' selected="selected"' : '') . '>' . JText::_('Name') . '</option>
					<option value="random"' . ($v_order == 'random' ? ' selected="selected"' : '') . '>' . JText::_('Random') . '</option>
				</select>
			</td>
		</tr>
	</table>

	<div>
		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		&nbsp; <input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</div>
</form>
';
	}

}

$engine = new PhotoSpotDatasourceBannersAdmin();

?>