<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceBannersDisplay extends PhotoSpotDatasourceDisplay {

	function init($viewer) {
		$db =& JFactory::getDBO();

		$catid = (int) $this->params->get('catid', '');

		$direct_link = (bool) $this->params->get('direct_link', '');
		if (!$direct_link)
			require_once(JPATH_SITE . '/components/com_content/helpers/route.php');

		$query_base =
'FROM #__banner
WHERE showBanner = 1
' . ($catid == 0 ? '' : 'AND catid = ' . $catid) . '
AND imageurl != ""
AND (imptotal = 0 OR impmade < imptotal)';

		$db->setQuery('SELECT COUNT(*) ' . $query_base);
		$this->items_count = (int) $db->loadResult();

		$order_sqls = array(
			'sticky_order' => 'sticky DESC, ordering',
			'sticky_date_desc' => 'sticky DESC, date DESC',
			'sticky_date_asc' => 'sticky DESC, date',
			'sticky_name' => 'sticky DESC, name',
			'sticky_random' => 'sticky DESC, RAND()',
			'order' => 'ordering',
			'date_desc' => 'date DESC',
			'date_asc' => 'date',
			'name' => 'name',
			'random' => 'RAND()',
		);
		$order = $this->params->get('order', '');
		$order_sql = isset($order_sqls[$order]) ? $order_sqls[$order] : $order_sqls['sticky_order'];

		$query =
'SELECT bid, name, imageurl, clickurl
' . $query_base . '
ORDER BY ' . $order_sql;

		$db->setQuery($query, $viewer->limitstart, $viewer->limit);
		$records = $db->loadObjectList();

		if (is_array($records)) {
			$url_prefix = JURI::base() . 'images/banners/';
			$abs_prefix = JPATH_SITE . '/images/banners/';

			foreach ($records as $rec) {
				$item = new PhotoSpotDisplayItem();

				if (strpos($rec->imageurl, '://') === false) {
					$item->img_url = $url_prefix . $rec->imageurl;
					$item->img_abs = $abs_prefix . $rec->imageurl;

					if (file_exists($item->img_abs)) {
						$info = getimagesize($item->img_abs);
						$item->img_width = $info[0];
						$item->img_height = $info[1];
					}
				}
				else {
					$item->img_url = $rec->imageurl;
				}

				$item->ext = strrchr(basename($rec->imageurl), '.');
				if (!empty($item->ext))
					$item->ext = strtolower(substr($item->ext, 1));

				$item->title = $rec->name;

				$item->link = $direct_link ? $rec->clickurl : JRoute::_('index.php?option=com_banners&task=click&bid=' . $rec->bid);

				$this->items[] = $item;
			}
		}

		return '';
	}

}

$engine = new PhotoSpotDatasourceBannersDisplay();

?>