<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceContentArticlesAdmin extends PhotoSpotDatasourceAdmin {

	function edit() {
		$load_data = true;

		$warnings = array();

		if ($this->get('hfrm_datasource_edit', '') != '') {
			$load_data = false;
			$v_articles = trim($this->get('articles', ''));
			$v_categories = trim($this->get('categories', ''));
			$v_sections = trim($this->get('sections', ''));
			$v_order = trim($this->get('order', ''));
			$v_select_imgsrc_order = $this->get('select_imgsrc_order', '');
			$v_search_thumbs = $this->get('search_thumbs', '');
			$v_select_title_order = $this->get('select_title_order', '');
			$v_select_descr_order = $this->get('select_descr_order', '');
			$v_select_descr_text = $this->get('select_descr_text', '');
			$v_descr_length_limit = trim($this->get('descr_length_limit', ''));			

			if ($this->page_refreshed) {
				// ignore page refreshes
			}
			else if ($this->get('btn_cancel', '') != '') {
				// form cancelled
				$load_data = true;
			}
			else {
				// form submitted successfully

				$error_msg = '';

				if ($v_descr_length_limit != '' && !ctype_digit($v_descr_length_limit))
					$error_msg = JText::_('The value for the description length limit is not a valid number');

				if ($error_msg == '') {
					$this->data_set('articles', $v_articles);
					$this->data_set('categories', $v_categories);
					$this->data_set('sections', $v_sections);
					$this->data_set('order', $v_order);
					$this->data_set('select_imgsrc_order', $v_select_imgsrc_order);
					$this->data_set('search_thumbs', $v_search_thumbs);
					$this->data_set('select_title_order', $v_select_title_order);
					$this->data_set('select_descr_order', $v_select_descr_order);
					$this->data_set('select_descr_text', $v_select_descr_text);
					$this->data_set('descr_length_limit', $v_descr_length_limit);
					$this->save();

					global $mainframe;
					$mainframe->enqueueMessage(JText::_('Datasource updated successfully'));
				}
				else {
					JError::raiseWarning($error_msg, $error_msg);
				}
			}
		}

		if ($load_data) {
			$v_articles = $this->data_get('articles', '');
			$v_categories = $this->data_get('categories', '');
			$v_sections = $this->data_get('sections', '');
			$v_order = $this->data_get('order', '');
			$v_select_imgsrc_order = $this->data_get('select_imgsrc_order', '');
			$v_search_thumbs = $this->data_get('search_thumbs', '');
			$v_select_title_order = $this->data_get('select_title_order', '');
			$v_select_descr_order = $this->data_get('select_descr_order', '');
			$v_select_descr_text = $this->data_get('select_descr_text', '');
			$v_descr_length_limit = $this->data_get('descr_length_limit', '');
		}

		echo '
<form name="frm_datasource" method="post" action="index.php">
	<input type="hidden" name="hfrm_datasource_edit" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="' . htmlspecialchars(JRequest::getCmd('id')) . '" />

	<input type="submit" name="dmsub" style="display:none" />

	<table cellspacing="10">
		<tr>
			<td valign="top">' . JText::_('Articles') . '</td>
			<td><input type="text" name="articles" value="' . htmlspecialchars($v_articles) . '" />
				&nbsp; ' . JText::_('Example') . ': 1, 2, 3
			</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Sections') . '</td>
			<td><input type="text" name="sections" value="' . htmlspecialchars($v_sections) . '" />
				&nbsp; ' . JText::_('Example') . ': 1, 2, 3
			</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Categories') . '</td>
			<td><input type="text" name="categories" value="' . htmlspecialchars($v_categories) . '" />
				&nbsp; ' . JText::_('Example') . ': 1, 2, 3
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Order by') . '</td>
			<td>
				<select name="order">
					<option value="default"' . ($v_order == 'default' ? ' selected="selected"' : '') . '>' . JText::_('Default order') . '</option>
					<option value="default_desc"' . ($v_order == 'default_desc' ? ' selected="selected"' : '') . '>' . JText::_('Reverse default order') . '</option>
					<option value="title_asc"' . ($v_order == 'title_asc' ? ' selected="selected"' : '') . '>' . JText::_('Title - Ascending') . '</option>
					<option value="title_desc"' . ($v_order == 'title_desc' ? ' selected="selected"' : '') . '>' . JText::_('Title - Descending') . '</option>
					<option value="cdate_desc"' . ($v_order == 'cdate_desc' ? ' selected="selected"' : '') . '>' . JText::_('Creation Date - Newer first') . '</option>
					<option value="cdate_asc"' . ($v_order == 'cdate_asc' ? ' selected="selected"' : '') . '>' . JText::_('Creation Date - Older first') . '</option>
					<option value="mdate_desc"' . ($v_order == 'mdate_desc' ? ' selected="selected"' : '') . '>' . JText::_('Last Modification Date - Newer first') . '</option>
					<option value="mdate_asc"' . ($v_order == 'mdate_asc' ? ' selected="selected"' : '') . '>' . JText::_('Last Modification Date - Older first') . '</option>
					<option value="random"' . ($v_order == 'random' ? ' selected="selected"' : '') . '>' . JText::_('Random') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Image selection order') . '</td>
			<td>
				<select name="select_imgsrc_order">
					<option value="artintro_artmain"' . ($v_select_imgsrc_order == 'artintro_artmain' ? ' selected="selected"' : '') . '>' . JText::_('Article intro - Main article') . '</option>
					<option value="artmain_artintro"' . ($v_select_imgsrc_order == 'artmain_artintro' ? ' selected="selected"' : '') . '>' . JText::_('Main article - Article intro') . '</option>
					<option value="artintro"' . ($v_select_imgsrc_order == 'artintro' ? ' selected="selected"' : '') . '>' . JText::_('Article intro') . '</option>
					<option value="artmain"' . ($v_select_imgsrc_order == 'artmain' ? ' selected="selected"' : '') . '>' . JText::_('Main article') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Search for small/large images') . '</td>
			<td><input type="checkbox" name="search_thumbs" value="1" ' . ($v_search_thumbs ? ' checked="checked"' : '') . ' /></td>
		</tr>
		<tr>
			<td>' . JText::_('Title selection order') . '</td>
			<td>
				<select name="select_title_order">
					<option value="arttitle"' . ($v_select_title_order == 'arttitle' ? ' selected="selected"' : '') . '>' . JText::_('Article title') . '</option>
					<option value="imgtitle_imgfilename"' . ($v_select_title_order == 'imgtitle_imgfilename' ? ' selected="selected"' : '') . '>' . JText::_('Image title - Image file name') . '</option>
					<option value="imgtitle_arttitle"' . ($v_select_title_order == 'imgtitle_arttitle' ? ' selected="selected"' : '') . '>' . JText::_('Image title - Article title') . '</option>
					<option value="imgfilename"' . ($v_select_title_order == 'imgfilename' ? ' selected="selected"' : '') . '>' . JText::_('Image file name') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Description selection order') . '</td>
			<td>
				<select name="select_descr_order">
					<option value="artintro_artmain"' . ($v_select_descr_order == 'artintro_artmain' ? ' selected="selected"' : '') . '>' . JText::_('Article intro - Main article') . '</option>
					<option value="artmain_artintro"' . ($v_select_descr_order == 'artmain_artintro' ? ' selected="selected"' : '') . '>' . JText::_('Main article - Article intro') . '</option>
					<option value="artintro"' . ($v_select_descr_order == 'artintro' ? ' selected="selected"' : '') . '>' . JText::_('Article intro') . '</option>
					<option value="artmain"' . ($v_select_descr_order == 'artmain' ? ' selected="selected"' : '') . '>' . JText::_('Main article') . '</option>
					<option value="imgtitle_imgfilename"' . ($v_select_descr_order == 'imgtitle_imgfilename' ? ' selected="selected"' : '') . '>' . JText::_('Image title - Image file name') . '</option>
					<option value="imgfilename"' . ($v_select_descr_order == 'imgfilename' ? ' selected="selected"' : '') . '>' . JText::_('Image file name') . '</option>
					<option value="none"' . ($v_select_descr_order == 'none' ? ' selected="selected"' : '') . '>' . JText::_('None') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Description text selection') . '</td>
			<td>
				<select name="select_descr_text">
					<option value="before_after"' . ($v_select_descr_text == 'before_after' ? ' selected="selected"' : '') . '>' . JText::_('Before or after the image') . '</option>
					<option value="before"' . ($v_select_descr_text == 'before' ? ' selected="selected"' : '') . '>' . JText::_('Before the image') . '</option>
					<option value="after"' . ($v_select_descr_text == 'after' ? ' selected="selected"' : '') . '>' . JText::_('After the image') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Description length limit') . '</td>
			<td><input type="text" name="descr_length_limit" value="' . htmlspecialchars($v_descr_length_limit) . '" /></td>
		</tr>
	</table>

	<div>
		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		&nbsp; <input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</div>
</form>
';
	}

}

$engine = new PhotoSpotDatasourceContentArticlesAdmin();

?>