<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceContentStoryAdmin extends PhotoSpotDatasourceAdmin {

	function setup() {
		$this->data_set('read_src', 'all');
		$this->data_set('split', 'image');
		$this->save();
	}

	function edit() {
		$load_data = true;

		$warnings = array();

		if ($this->get('hfrm_datasource_edit', '') != '') {
			$load_data = false;
			$v_article_id = trim($this->get('article_id', ''));
			$v_read_src = trim($this->get('read_src', 'all'));
			$v_split = trim($this->get('split', 'image'));
			$v_search_thumbs = $this->get('search_thumbs', '');
			$v_order = $this->get('order', '');

			if ($this->page_refreshed) {
				// ignore page refreshes
			}
			else if ($this->get('btn_cancel', '') != '') {
				// form cancelled
				$load_data = true;
			}
			else {
				// form submitted successfully

				$this->data_set('article_id', $v_article_id);
				$this->data_set('read_src', $v_read_src);
				$this->data_set('split', $v_split);
				$this->data_set('search_thumbs', $v_search_thumbs);
				$this->data_set('order', $v_order);
				$this->save();

				global $mainframe;
				$mainframe->enqueueMessage(JText::_('Datasource updated successfully'));
			}
		}

		if ($load_data) {
			$v_article_id = $this->data_get('article_id', '');
			$v_read_src = $this->data_get('read_src', '');
			$v_split = $this->data_get('split', '');
			$v_search_thumbs = $this->data_get('search_thumbs', '');
			$v_order = $this->data_get('order', '');
		}

		echo '
<form name="frm_datasource" method="post" action="index.php">
	<input type="hidden" name="hfrm_datasource_edit" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="' . htmlspecialchars(JRequest::getCmd('id')) . '" />

	<input type="submit" name="dmsub" style="display:none" />

	<table cellspacing="10">
		<tr>
			<td>' . JText::_('Article ID') . '</td>
			<td><input type="text" name="article_id" value="' . htmlspecialchars($v_article_id) . '" /></td>
		</tr>
		<tr>
			<td>' . JText::_('Read source') . '</td>
			<td>
				<select name="read_src">
					<option value="all"' . ($v_read_src == 'all' ? ' selected="selected"' : '') . '>' . JText::_('Intro + Main') . '</option>
					<option value="intro"' . ($v_read_src == 'intro' ? ' selected="selected"' : '') . '>' . JText::_('Intro') . '</option>
					<option value="main"' . ($v_read_src == 'main' ? ' selected="selected"' : '') . '>' . JText::_('Main') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Split method') . '</td>
			<td>
				<select name="split">
					<option value="image"' . ($v_split == 'image' ? ' selected="selected"' : '') . '>' . JText::_('Image') . '</option>
					<option value="pagebreak"' . ($v_split == 'pagebreak' ? ' selected="selected"' : '') . '>' . JText::_('Page break') . '</option>
					<option value="nosplit"' . ($v_split == 'nosplit' ? ' selected="selected"' : '') . '>' . JText::_('Do not split') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Search for small/large images') . '</td>
			<td><input type="checkbox" name="search_thumbs" value="1" ' . ($v_search_thumbs ? ' checked="checked"' : '') . ' /></td>
		</tr>
		<tr>
			<td>' . JText::_('Order by') . '</td>
			<td>
				<select name="order">
					<option value="default"' . ($v_order == 'default' ? ' selected="selected"' : '') . '>' . JText::_('Default order') . '</option>
					<option value="default_desc"' . ($v_order == 'default_desc' ? ' selected="selected"' : '') . '>' . JText::_('Reverse default order') . '</option>
					<option value="filename_asc"' . ($v_order == 'filename_asc' ? ' selected="selected"' : '') . '>' . JText::_('File name - Ascending') . '</option>
					<option value="filename_desc"' . ($v_order == 'filename_desc' ? ' selected="selected"' : '') . '>' . JText::_('File name - Descending') . '</option>
					<option value="title_asc"' . ($v_order == 'title_asc' ? ' selected="selected"' : '') . '>' . JText::_('Title - Ascending') . '</option>
					<option value="title_desc"' . ($v_order == 'title_desc' ? ' selected="selected"' : '') . '>' . JText::_('Title - Descending') . '</option>
					<option value="mdate_desc"' . ($v_order == 'mdate_desc' ? ' selected="selected"' : '') . '>' . JText::_('Date - Newer first') . '</option>
					<option value="mdate_asc"' . ($v_order == 'mdate_asc' ? ' selected="selected"' : '') . '>' . JText::_('Date - Older first') . '</option>
					<option value="random"' . ($v_order == 'random' ? ' selected="selected"' : '') . '>' . JText::_('Random') . '</option>
				</select>
			</td>
		</tr>

	</table>

	<div>
		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		&nbsp; <input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</div>
</form>
';
	}

}

$engine = new PhotoSpotDatasourceContentStoryAdmin();

?>