<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceVmCategoriesAdmin extends PhotoSpotDatasourceAdmin {

	function setup() {
		$this->data_set('cur_vendor', '1');
		$this->save();
	}

	function edit() {
		$load_data = true;

		if ($this->get('hfrm_datasource_edit', '') != '') {
			$load_data = false;
			$v_categories = trim($this->get('categories', ''));
			$v_cur_vendor = trim($this->get('cur_vendor', '0'));
			$v_display = trim($this->get('display', ''));
			$v_order = trim($this->get('order', ''));

			if ($this->page_refreshed) {
				// ignore page refreshes
			}
			else if ($this->get('btn_cancel', '') != '') {
				// form cancelled
				$load_data = true;
			}
			else {
				// form submitted successfully

				$this->data_set('categories', $v_categories);
				$this->data_set('cur_vendor', $v_cur_vendor);
				$this->data_set('display', $v_display);
				$this->data_set('order', $v_order);
				$this->save();

				global $mainframe;
				$mainframe->enqueueMessage(JText::_('Datasource updated successfully'));
			}
		}

		if ($load_data) {
			$v_categories = $this->data_get('categories', '');
			$v_cur_vendor = $this->data_get('cur_vendor', '');
			$v_display = $this->data_get('display', '');
			$v_order = $this->data_get('order', '');
		}

		if (!file_exists(JPATH_SITE . '/components/com_virtuemart/virtuemart_parser.php'))
			echo '
<p class="warning">' . JText::_('Warning: VirtueMart is not installed in your system') . '</p>
';

		echo '
<form name="frm_datasource" method="post" action="index.php">
	<input type="hidden" name="hfrm_datasource_edit" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="' . htmlspecialchars(JRequest::getCmd('id')) . '" />

	<input type="submit" name="dmsub" style="display:none" />

	<table cellspacing="10">
		<tr>
			<td valign="top">' . JText::_('Vendor') . '</td>
			<td><input type="checkbox" name="cur_vendor" value="1"' . ($v_cur_vendor ? ' checked="checked"' : '') . ' /> ' . JText::_('Show only the products of the current vendor') . '</td>
		</tr>
		<tr>
			<td>' . JText::_('Display method') . '</td>
			<td>
				<select name="display">
					<option value="all"' . ($v_display == 'all' ? ' selected="selected"' : '') . '>' . JText::_('All categories') . '</option>
					<option value="selected"' . ($v_display == 'selected' ? ' selected="selected"' : '') . '>' . JText::_('Selected categories') . '</option>
					<option value="subcats"' . ($v_display == 'subcats' ? ' selected="selected"' : '') . '>' . JText::_('Sub-categories') . '</option>
				</select>
			</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Selected / Sub-categories') . '</td>
			<td><input type="text" name="categories" value="' . htmlspecialchars($v_categories) . '" />
				&nbsp; ' . JText::_('Example') . ': 1, 2, 3
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Order by') . '</td>
			<td>
				<select name="order">
					<option value="default"' . ($v_order == 'default' ? ' selected="selected"' : '') . '>' . JText::_('Default order') . '</option>
					<option value="name"' . ($v_order == 'name' ? ' selected="selected"' : '') . '>' . JText::_('Name') . '</option>
					<option value="mdate_desc"' . ($v_order == 'mdate_desc' ? ' selected="selected"' : '') . '>' . JText::_('Date - Newer first') . '</option>
					<option value="mdate_asc"' . ($v_order == 'mdate_asc' ? ' selected="selected"' : '') . '>' . JText::_('Date - Older first') . '</option>
					<option value="random"' . ($v_order == 'random' ? ' selected="selected"' : '') . '>' . JText::_('Random categories') . '</option>
				</select>
			</td>
		</tr>
	</table>

	<div>
		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		&nbsp; <input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</div>
</form>
';
	}

}

$engine = new PhotoSpotDatasourceVmCategoriesAdmin();

?>