<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceVmCategoriesDisplay extends PhotoSpotDatasourceDisplay {

	function init($viewer) {
		if (!defined('_VM_PARSER_LOADED')) {
			$ini_filename = JPATH_SITE . '/components/com_virtuemart/virtuemart_parser.php';
			if (file_exists($ini_filename))
				require_once($ini_filename);
		}

		if (!defined('_VM_PARSER_LOADED'))
			return;

		preg_match_all('/[0-9]+/', $this->params->get('categories', ''), $cat_ids);

		$cur_vendor = (bool) $this->params->get('cur_vendor', '1');

		if (empty($viewer->limit))
			$viewer->limit = 100;

		$display = $this->params->get('display', '');

		if ($display != 'all' && empty($cat_ids[0]))
			return;

		if ($display == 'selected')
			$query_base = "FROM #__{vm}_category c WHERE c.category_id IN (" . implode(", ", $cat_ids[0]) . ") AND c.category_publish = 'Y'";
		else if ($display == 'subcats')
			$query_base = "FROM #__{vm}_category c, #__{vm}_category_xref x WHERE x.category_parent_id IN (" . implode(", ", $cat_ids[0]) . ") AND x.category_child_id = c.category_id AND c.category_publish = 'Y'";
		else
			$query_base = "FROM #__{vm}_category c WHERE c.category_publish = 'Y'";

		if ($cur_vendor)
			$query_base .= " AND c.vendor_id = '{$_SESSION['ps_vendor_id']}'";


		$order = $this->params->get('order', '');
		if ($order == 'name')
			$sql_order = "ORDER BY c.category_name";
		else if ($order == 'mdate_desc')
			$sql_order = "ORDER BY c.mdate DESC";
		else if ($order == 'mdate_asc')
			$sql_order = "ORDER BY c.mdate";
		else if ($order == 'random')
			$sql_order = "ORDER BY RAND()";
		else
			$sql_order = "ORDER BY c.list_order";

		$sql_limit = '';
		if ($viewer->limitstart > 0 || $viewer->limit > 0)
			$sql_limit = 'LIMIT ' . $viewer->limitstart . ', ' . $viewer->limit;

		global $sess, $mm_action_url;

		$url_root = JURI::root();
		$img_url_base = $url_root . 'components/com_virtuemart/shop_image/category/';
		$img_abs_base = JPATH_SITE . '/components/com_virtuemart/shop_image/category/';

		$thumb_url_base = $img_url_base . 'resized/';
		$thumb_abs_base = $img_abs_base . 'resized/';


		// prepare image for categories without images

		$noimage_url = VM_THEMEURL . 'images/' . NO_IMAGE;
		$noimage_abs = false;
		$noimage_ext = false;
		$noimage_width = false;
		$noimage_height = false;
		$noimage_mime = false;

		if (substr($noimage_url, 0, strlen($url_root)) == $url_root)
			$noimage_abs = JPATH_SITE . '/' . substr($noimage_url, strlen($url_root));

		if (!empty($noimage_abs) && !file_exists($noimage_abs))
			$noimage_abs = false;

		if (!empty($noimage_abs)) {
			$info = getimagesize($noimage_abs);
			$noimage_width = $info[0];
			$noimage_height = $info[1];
			$noimage_mime = @$info['mime'];

			$noimage_ext = strrchr(basename($noimage_abs), '.');
			if (!empty($noimage_ext))
				$noimage_ext = strtolower(substr($noimage_ext, 1));
		}


		// load data

		$db = new ps_DB;
		$db_cat = new ps_DB;

		$db->query("SELECT COUNT(*) AS countt " . $query_base);
		if ($db->next_record())
			$this->items_count = (int) $db->f("countt");

		$db->query(
"SELECT c.category_id, c.category_name, c.category_description, c.category_full_image, c.category_thumb_image, c.mdate
$query_base
$sql_order
$sql_limit"
		);

		while ($db->next_record()) {
			$item = new PhotoSpotDisplayItem();

			$item->title = $db->f('category_name');

			$item->description = $db->f('category_description');

			$item->link = $sess->url(URL."index.php?page=shop.browse&amp;category_id=".$db->f('category_id'));


			// process main image

			$filename = $db->f('category_full_image');
			if (!empty($filename) && file_exists($img_abs_base . $filename)) {
				$item->img_url = $img_url_base . $filename;
				$item->img_abs = $img_abs_base . $filename;

				$item->ext = strrchr(basename($filename), '.');
				if (!empty($item->ext))
					$item->ext = strtolower(substr($item->ext, 1));

				$info = getimagesize($item->img_abs);
				$item->img_width = $info[0];
				$item->img_height = $info[1];
				$item->mime = @$info['mime'];
			}
			else {
				$item->img_url = $noimage_url;
				$item->img_abs = $noimage_abs;
				$item->ext = $noimage_ext;
				$item->img_width = $noimage_width;
				$item->img_height = $noimage_height;
				$item->mime = $noimage_mime;
			}


			// process thumbnail

			$filename = $db->f('category_thumb_image');
			if (!empty($filename) && file_exists($thumb_abs_base . $filename)) {
				$item->thumb_url = $thumb_url_base . $filename;
				$item->thumb_abs = $thumb_abs_base . $filename;

				$info = getimagesize($item->thumb_abs);
				$item->thumb_width = $info[0];
				$item->thumb_height = $info[1];
			}


			$item->mtime = (int) $db->f('mdate');

			$this->items[] = $item;
		}

		return '';
	}

}

$engine = new PhotoSpotDatasourceVmCategoriesDisplay();

?>