<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceVmItemsAdmin extends PhotoSpotDatasourceAdmin {

	function setup() {
		$this->data_set('cur_vendor', '1');
		$this->data_set('regular_link', '1');
		$this->save();
	}

	function edit() {
		$load_data = true;

		if ($this->get('hfrm_datasource_edit', '') != '') {
			$load_data = false;
			$v_products = trim($this->get('products', ''));
			$v_categories = trim($this->get('categories', ''));
			$v_cur_vendor = trim($this->get('cur_vendor', '0'));
			$v_regular_link = trim($this->get('regular_link', '0'));
			$v_display = trim($this->get('display', ''));

			if ($this->page_refreshed) {
				// ignore page refreshes
			}
			else if ($this->get('btn_cancel', '') != '') {
				// form cancelled
				$load_data = true;
			}
			else {
				// form submitted successfully

				$this->data_set('products', $v_products);
				$this->data_set('categories', $v_categories);
				$this->data_set('cur_vendor', $v_cur_vendor);
				$this->data_set('regular_link', $v_regular_link);
				$this->data_set('display', $v_display);
				$this->save();

				global $mainframe;
				$mainframe->enqueueMessage(JText::_('Datasource updated successfully'));
			}
		}

		if ($load_data) {
			$v_products = $this->data_get('products', '');
			$v_categories = $this->data_get('categories', '');
			$v_cur_vendor = $this->data_get('cur_vendor', '');
			$v_regular_link = $this->data_get('regular_link', '');
			$v_display = $this->data_get('display', '');
		}

		if (!file_exists(JPATH_SITE . '/components/com_virtuemart/virtuemart_parser.php'))
			echo '
<p class="warning">' . JText::_('Warning: VirtueMart is not installed in your system') . '</p>
';

		echo '
<form name="frm_datasource" method="post" action="index.php">
	<input type="hidden" name="hfrm_datasource_edit" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="' . htmlspecialchars(JRequest::getCmd('id')) . '" />

	<input type="submit" name="dmsub" style="display:none" />

	<table cellspacing="10">
		<tr>
			<td valign="top">' . JText::_('Selected products') . '</td>
			<td><input type="text" name="products" value="' . htmlspecialchars($v_products) . '" />
				&nbsp; ' . JText::_('Example') . ': 1, 2, 3
		</tr>
		<tr>
			<td valign="top">' . JText::_('Categories') . '</td>
			<td><input type="text" name="categories" value="' . htmlspecialchars($v_categories) . '" />
				&nbsp; ' . JText::_('Example') . ': 1, 2, 3
			</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Vendor') . '</td>
			<td><input type="checkbox" name="cur_vendor" value="1"' . ($v_cur_vendor ? ' checked="checked"' : '') . ' /> ' . JText::_('Show only the products of the current vendor') . '</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Link type') . '</td>
			<td>
				<input type="radio" name="regular_link" value="1"' . ($v_regular_link ? ' checked="checked"' : '') . ' /> ' . JText::_('Regular link') . '
				&nbsp; <input type="radio" name="regular_link" value="0"' . ($v_regular_link ? '' : ' checked="checked"') . ' /> ' . JText::_('Product URL') . '
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Display method') . '</td>
			<td>
				<select name="display">
					<option value="random"' . ($v_display == 'random' ? ' selected="selected"' : '') . '>' . JText::_('Random products') . '</option>
					<option value="featured"' . ($v_display == 'featured' ? ' selected="selected"' : '') . '>' . JText::_('Featured products') . '</option>
					<option value="latest"' . ($v_display == 'latest' ? ' selected="selected"' : '') . '>' . JText::_('Latest products') . '</option>
					<option value="topten"' . ($v_display == 'topten' ? ' selected="selected"' : '') . '>' . JText::_('Best selling products') . '</option>
					<option value="selected"' . ($v_display == 'selected' ? ' selected="selected"' : '') . '>' . JText::_('Selected products') . '</option>
				</select>
			</td>
		</tr>
	</table>

	<div>
		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		&nbsp; <input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</div>
</form>
';
	}

}

$engine = new PhotoSpotDatasourceVmItemsAdmin();

?>