<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotDatasourceVmItemsDisplay extends PhotoSpotDatasourceDisplay {

	function init($viewer) {
		if (!defined('_VM_PARSER_LOADED')) {
			$ini_filename = JPATH_SITE . '/components/com_virtuemart/virtuemart_parser.php';
			if (file_exists($ini_filename))
				require_once($ini_filename);
		}

		if (!defined('_VM_PARSER_LOADED'))
			return;

		require_once(JPATH_SITE . '/components/com_content/helpers/route.php');

		preg_match_all('/[0-9]+/', $this->params->get('products', ''), $prd_ids);

		preg_match_all('/[0-9]+/', $this->params->get('categories', ''), $cat_ids);

		$cur_vendor = (bool) $this->params->get('cur_vendor', '1');

		$regular_link = (bool) $this->params->get('regular_link', '1');

		if (empty($viewer->limit))
			$viewer->limit = 100;

		$sql_order = '';

		$display = $this->params->get('display', '');
		if ($display == 'selected') {
			$query_base = "FROM #__{vm}_product p WHERE p.product_id IN ('" . implode("','", $prd_ids[0]) . "')";
		}
		else {
			$sql_extra = '';

			switch ($display) {
				case 'featured':
					$sql_extra = "AND p.product_special = 'Y'";
					$sql_order = "ORDER BY RAND()";
					break;

				case 'latest':
					$sql_order = "ORDER BY p.product_id DESC";
					break;

				case 'topten':
					$sql_extra = "AND p.product_sales > 0";
					$sql_order = "ORDER BY p.product_sales DESC, p.product_name";
					break;

				case 'random':
				default:
					$sql_order = "ORDER BY RAND()";
			}

			$query_base =
"FROM #__{vm}_product p" . (empty($cat_ids[0]) ? "" : ", #__{vm}_product_category_xref l") . "
WHERE p.product_parent_id = 0
$sql_extra
AND p.product_publish = 'Y'
" . ($cur_vendor ? "AND p.vendor_id = '{$_SESSION['ps_vendor_id']}'" : "") . "
" . (CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1" ? "AND p.product_in_stock > 0 " : "") . "
" . (empty($cat_ids[0]) ? "" : "AND p.product_id = l.product_id AND l.category_id IN (" . implode(",", $cat_ids[0]) . ")");
		}

		$sql_limit = '';
		if ($viewer->limitstart > 0 || $viewer->limit > 0)
			$sql_limit = 'LIMIT ' . $viewer->limitstart . ', ' . $viewer->limit;

		global $sess, $mm_action_url;

		require_once(CLASSPATH . 'ps_product.php');
		$ps_product = new ps_product;

		$url_root = JURI::root();
		$img_url_base = $url_root . 'components/com_virtuemart/shop_image/product/';
		$img_abs_base = JPATH_SITE . '/components/com_virtuemart/shop_image/product/';

		$thumb_url_base = $img_url_base . 'resized/';
		$thumb_abs_base = $img_abs_base . 'resized/';


		// prepare image for products without images

		$noimage_url = VM_THEMEURL . 'images/' . NO_IMAGE;
		$noimage_abs = false;
		$noimage_ext = false;
		$noimage_width = false;
		$noimage_height = false;
		$noimage_mime = false;

		if (substr($noimage_url, 0, strlen($url_root)) == $url_root)
			$noimage_abs = JPATH_SITE . '/' . substr($noimage_url, strlen($url_root));

		if (!empty($noimage_abs) && !file_exists($noimage_abs))
			$noimage_abs = false;

		if (!empty($noimage_abs)) {
			$info = getimagesize($noimage_abs);
			$noimage_width = $info[0];
			$noimage_height = $info[1];
			$noimage_mime = @$info['mime'];

			$noimage_ext = strrchr(basename($noimage_abs), '.');
			if (!empty($noimage_ext))
				$noimage_ext = strtolower(substr($noimage_ext, 1));
		}


		// load data

		$db = new ps_DB;
		$db_cat = new ps_DB;

		$db->query("SELECT COUNT(*) AS countt " . $query_base);
		if ($db->next_record())
			$this->items_count = (int) $db->f("countt");

		$db->query(
"SELECT p.product_id, p.product_parent_id, p.product_name, p.product_s_desc, p.product_url, p.product_full_image, p.product_thumb_image,
	p.product_width, p.product_height, p.mdate
$query_base
$sql_order
$sql_limit"
		);

		while ($db->next_record()) {
			$item = new PhotoSpotDisplayItem();

			$item->title = $db->f('product_name');

			$item->description = $db->f('product_s_desc');

			if ($regular_link) {
				$cid = 0;
				$db_cat->query("SELECT category_id FROM #__{vm}_product_category_xref WHERE product_id = " . intval($db->f("product_id")));
				if ($db_cat->next_record())
					$cid = intval($db_cat->f("category_id"));

				if ($db->f("product_parent_id")) {
					$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_parent_id"));
					$url .= "&product_id=" . $db->f("product_parent_id");
				}
				else {
					$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_id"));
					$url .= "&product_id=" . $db->f("product_id");
				}

				$item->link = $sess->url($mm_action_url. "index.php" . $url);
			}
			else {
				$item->link = trim($db->f('product_url'));
				if (!empty($item->link) && strpos($item->link, '://') === false)
					$item->link = JRoute::_($item->link);
			}


			// process main image

			$filename = $db->f('product_full_image');
			if (!empty($filename) && file_exists($img_abs_base . $filename)) {
				$item->img_url = $img_url_base . $filename;
				$item->img_abs = $img_abs_base . $filename;

				$item->ext = strrchr(basename($filename), '.');
				if (!empty($item->ext))
					$item->ext = strtolower(substr($item->ext, 1));

				$info = getimagesize($item->img_abs);
				$item->img_width = $info[0];
				$item->img_height = $info[1];
				$item->mime = @$info['mime'];
			}
			else {
				$item->img_url = $noimage_url;
				$item->img_abs = $noimage_abs;
				$item->ext = $noimage_ext;
				$item->img_width = $noimage_width;
				$item->img_height = $noimage_height;
				$item->mime = $noimage_mime;
			}


			// process thumbnail

			$filename = $db->f('product_thumb_image');
			if (!empty($filename) && file_exists($thumb_abs_base . $filename))
				$item->thumb_abs = $thumb_abs_base . $filename;

			if (!empty($filename) && empty($item->thumb_abs)) {
				$height = (int) $db->f('product_width');
				$width = (int) $db->f('product_width');
				$ext = strrchr(basename($filename), '.');
				if ($height > 0 && $width > 0 && $ext != '') {
					$filename = substr($filename, 0, -strlen($ext)) . '_' . $height . 'x' . $width . $ext;
					if (file_exists($thumb_abs_base . $filename))
						$item->thumb_abs = $thumb_abs_base . $filename;
				}
			}

			if (!empty($item->thumb_abs)) {
				$item->thumb_url = $thumb_url_base . $filename;

				$info = getimagesize($item->thumb_abs);
				$item->thumb_width = $info[0];
				$item->thumb_height = $info[1];
			}


			$item->mtime = (int) $db->f('mdate');

			$this->items[] = $item;
		}

		return '';
	}

}

$engine = new PhotoSpotDatasourceVmItemsDisplay();

?>