<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */

class PhotoSpotViewerCustomDesignPH {
	var $id = 0;
	var $key = '';
	var $td_content = '';
	var $td_slash = '';
	var $splitter_content = '';
	var $src = '';
	var $width = 0;
	var $height = 0;
	var $img_slash = '';
	var $orig_img = '';

	var $handled = false;

	function get($back, $ho, $class) {
		$this->handled = true;

		$result = '<td' . $this->td_content;

		if ($this->width > 0)
			$result .= ' width="' . $this->width . '"';

		if ($this->height > 0)
			$result .= ' height="' . $this->height . '"';

		if ($back && $this->src != '')
			$result .= ' style="background:url(' . $this->src . ') no-repeat;"';

		$result .= $this->td_slash . '>' . $this->splitter_content;

		$result .= '<div style="width:' . $this->width . 'px;height:' . $this->height . 'px;' . ($ho ? 'overflow:hidden;' : '') . '"' . ($class == '' ? '' : ' class="' . $class . '"') . '>';

		return $result;
	}

	function get_orig($class) {
		return $this->get(false, false, $class) . $this->orig_img;
	}

	function get_rpl($back, $ho, $class, $code) {
		return $this->get($back, $ho, $class) . $code . '</div>';
	}
}

class PhotoSpotViewerCustomDesignDisplay extends PhotoSpotViewerDisplay {
	var $content = '';
	var $key = '';
	var $ph_all = array(); // all place holders
	var $ph_images = array(); // place holders for images
	var $ph_titles = array(); // place holders for titles
	var $ph_pagescounter = false; // place holder for page counter
	var $ph_resultscounter = false; // place holder for results counter
	var $ph_pages = false; // place holder for pagination

	var $pageNav = false;

	var $match_counter = 0;
	var $match_limit = 1000;

	function cb_image($m) {
		if ($this->match_counter >= $this->match_limit)
			return str_replace('src="images/', 'src="' . $this->img_base, $m[0]);

		$this->match_counter++;


		// analyse img
		$src = false;
		$id = false;
		$width = false;
		$height = false;
		preg_match_all('~(\w*)="([^"]*)"~', $m[4], $p);
		foreach ($p[1] as $k => $v) {
			$v = strtolower($v);

			if ($v == 'src')
				$src = $p[2][$k];
			else if ($v == 'id')
				$id = $p[2][$k];
			else if ($v == 'width')
				$width = (int) $p[2][$k];
			else if ($v == 'height')
				$height = (int) $p[2][$k];
		}

		$match = 0;

		if ($id !== false && preg_match('/^image(\d*)$/i', $id, $j))
			$match = 1;
		else if ($id !== false && preg_match('/^title(\d*)$/i', $id, $j))
			$match = 2;
		else if ($id !== false && preg_match('/^pages$/i', $id, $j))
			$match = 3;
		else if ($id !== false && preg_match('/^pagescounter$/i', $id, $j))
			$match = 4;
		else if ($id !== false && preg_match('/^resultscounter$/i', $id, $j))
			$match = 5;

		if ($match == 0) {
			// element is not a place holder
			$result = str_replace('src="images/', 'src="' . $this->img_base, $m[0]);
		}
		else {
			$r = new PhotoSpotViewerCustomDesignPH();

			if (preg_match('~/\s*$~', $m[1], $h)) {
				$r->td_content = substr($m[1], 0, -strlen($h[0]));
				$r->td_slash = '/';
			}
			else {
				$r->td_content = $m[1];
				$r->td_slash = '';
			}

			$r->splitter_content = $m[2];

			$r->src = str_replace('images/', $this->img_base, $src);
			$r->width = $width;
			$r->height = $height;

			if (preg_match('~/\s*$~', $m[4]))
				$r->img_slash = '/';

			$r->orig_img = str_replace('images/', $this->img_base, $m[3]);

			if ($match == 1) {
				// element is a place holder for an image
				$r->id = intval($j[1]) - 1;
				$r->key = $this->key . 'image' . $j[1] . '=';
				$this->ph_images[$r->id] = $r;
			}
			else if ($match == 2) {
				// element is a place holder for a title
				$r->id = intval($j[1]) - 1;
				$r->key = $this->key . 'title' . $j[1] . '=';
				$this->ph_titles[$r->id] = $r;
			}
			else if ($match == 3) {
				// element is a place holder for pagination
				$r->key = $this->key . 'pagelinks';
				$this->ph_pages = $r;
			}
			else if ($match == 4) {
				// element is a place holder for the page counter
				$r->key = $this->key . 'pagescounter';
				$this->ph_pagescounter = $r;
			}
			else if ($match == 5) {
				// element is a place holder for the results counter
				$r->key = $this->key . 'resultscounter';
				$this->ph_resultscounter = $r;
			}

			$this->ph_all[] = $r;
			$result = $r->key;
		}

		return $result;
	}

	function init() {
		$theme_filename = trim($this->params->get('theme', ''));
		if ($theme_filename == '') {
			echo JText::_('The gallery source file is not set');
			return;
		}

		$utils =& PhotoSpotUtils::get_instance();

		$type = $utils->norm_file_paths($theme_filename, false, $path_url, $path_abs);
		if ($type == 'notfound') {
			echo JText::_('The gallery source file not found');
			return;
		}
		else if ($type != 'file') {
			echo JText::_('The gallery source is not a file');
			return;
		}

		$this->img_base = dirname($path_url) . '/images/';

		$this->content = $utils->get_html_body($path_abs);

		// remove comments
		$this->content = preg_replace('/<!--.*?-->/', '', $this->content);

		// find a unique key for the image place holders
		$i = 0;
		while (true) {
			$i++;
			if ($i > 100)
				die('Cannot find a unique key for the image place holders');

			$this->key = md5(mt_rand(1, 1000000)) . '_';
			if (strpos($this->content, $this->key) === false)
				break;
		}

		// adjust images
		$this->content = preg_replace_callback('/<td([^>]*)>(\s*)(<\s*img([^>]*)>)/is', array(get_class($this), 'cb_image'), $this->content);
		ksort($this->ph_images);

		// calculate pagination information for datasource
		$this->limit = count($this->ph_images);
		$this->limitstart = (int) JRequest::getCmd('limitstart');

		return '';
	}

	function setup_pagenav($items_count) {
		if ($this->pageNav === false) {
			jimport('joomla.html.pagination');
			$this->pageNav = new JPagination($items_count, $this->limitstart, $this->limit);
		}
	}

	function render($ds) {
		$css_file = trim($this->params->get('css_file', ''));
		if ($css_file != '') {
			$document =& JFactory::getDocument();
			$document->addStyleSheet($css_file);
		}

		$open_method = $this->params->get('open', '');
		$lightbox_group_name = 'photospot';

		$background = $this->params->get('background', '');
		$background = !empty($background);

		$i = -1;
		foreach ($this->ph_images as $p) {
			$i++;
			$this->ph_images[$p->id]->idx = $i;

			if (isset($ds->items[$i])) {
				$title = htmlspecialchars($ds->items[$i]->get_title());
				$title_a = $title == '' ? '' : ' title="' . $title . '"';

				$ds->items[$i]->get_thumb_size($p->width, $p->height, $thumb, $width, $height);

				$a_open = '';
				$a_close = '';

				switch ($open_method) {
					case 'popup':
						$str = '';

						if ($ds->items[$i]->img_width > 0)
							$str .= ',width=' . $ds->items[$i]->img_width;

						if ($ds->items[$i]->img_height > 0)
							$str .= ',height=' . $ds->items[$i]->img_height;


						$a_open = '<a href="javascript:void(0)" onclick="window.open(\'' . $ds->items[$i]->img_url . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes' . $str . '\')"' . $title_a . '>';
						$a_close = '</a>';
						break;

					case 'link':
						if (!empty($ds->items[$i]->link)) {
							$a_open = '<a href="' . $ds->items[$i]->link . '"' . $title_a . '>';
							$a_close = '</a>';
						}
						break;

					case 'linkpopup':
						if (!empty($ds->items[$i]->link)) {
							$a_open = '<a href="javascript:void(0)" onclick="window.open(\'' . $ds->items[$i]->link . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=700,height=600\')"' . $title_a . '>';
							$a_close = '</a>';
						}
						break;

					case 'thumbnails':
						break;

					case 'lightbox':
					default:
						$this->enable_lightbox();
						$a_open = '<a href="' . $ds->items[$i]->img_url . '" rel="lightbox[' . $lightbox_group_name . ']"' . $title_a . '>';
						$a_close = '</a>';
				}

				$replacement = sprintf(
					'%s<img src="%s"%s%s alt="%s" border="0"%s>%s',
					$a_open, // opening
					$thumb, // src
					$width == 0 ? '' : ' width="' . $width . '"', // more 1
					$height == 0 ? '' : ' height="' . $height . '"', // more 2
					$title, // alt
					$p->img_slash, // img closing
					$a_close // closing
				);
				$replacement = $p->get_rpl(
					$this->params->get('bg_images', '') == '1',
					false,
					$this->params->get('cl_images', ''),
					$replacement
				);
			}
			else {
				// no data found for place holder
				$replacement = $p->get_orig($this->params->get('cl_no_images', ''));
			}

			$this->content = str_replace($p->key, $replacement, $this->content);
		}

		$titles = $this->params->get('titles', '');

		foreach ($this->ph_titles as $p) {
			$i = -1;
			if (isset($this->ph_images[$p->id]))
				$i = $this->ph_images[$p->id]->idx;

			if ($i > -1 && isset($ds->items[$i])) {
				$title = htmlspecialchars($ds->items[$i]->get_title());
				$title_a = $title == '' ? '' : ' title="' . $title . '"';

				if ($title == '') {
					$title = '&nbsp;';
				}
				else {
					switch($titles) {
						case 'link':
							if (!empty($ds->items[$i]->link))
								$title = '<a href="' . $ds->items[$i]->link . '"' . $title_a . '>' . $title . '</a>';
							break;

						case 'linkpopup':
							if (!empty($ds->items[$i]->link))
								$title = '<a href="javascript:void(0)" onclick="window.open(\'' . $ds->items[$i]->link . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=700,height=600\')"' . $title_a . '>' . $title . '</a>';
							break;

						case 'no':
							$title = '&nbsp;';
							break;

						case 'show':
						default:
					}
				}

 				$replacement = $p->get_rpl(
					$this->params->get('bg_titles', '') == '1',
					$this->params->get('ho_titles', '') == '1',
					$this->params->get('cl_titles', ''),
					$title
				);
			}
			else {
				// no data found for place holder
 				$replacement = $p->get_orig($this->params->get('cl_no_titles', ''));
			}

			$this->content = str_replace($p->key, $replacement, $this->content);
		}

		if ($this->ph_pages !== false) {
			$this->setup_pagenav($ds->items_count);
			if ($ds->items_count > $this->limit)
				$replacement = $this->ph_pages->get_rpl(
					$this->params->get('bg_pages', '') == '1',
					$this->params->get('ho_pages', '') == '1',
					$this->params->get('cl_pages', ''),
					$this->pageNav->getPagesLinks()
				);
			else
				$replacement = $this->ph_pages->get_orig($this->params->get('cl_no_pages', ''));

			$this->content = str_replace($this->ph_pages->key, $replacement, $this->content);
		}

		if ($this->ph_pagescounter !== false) {
			$this->setup_pagenav($ds->items_count);
			if ($ds->items_count > $this->limit)
				$replacement = $this->ph_pagescounter->get_rpl(
					$this->params->get('bg_pagescounter', '') == '1',
					$this->params->get('ho_pagescounter', '') == '1',
					$this->params->get('cl_pagescounter', ''),
					$this->pageNav->getPagesCounter()
				);
			else
				$replacement = $this->ph_pagescounter->get_orig($this->params->get('cl_no_pagescounter', ''));

			$this->content = str_replace($this->ph_pagescounter->key, $replacement, $this->content);
		}

		if ($this->ph_resultscounter !== false) {
			$this->setup_pagenav($ds->items_count);
			if ($ds->items_count > $this->limit)
				$replacement = $this->ph_resultscounter->get_rpl(
					$this->params->get('bg_resultscounter', '') == '1',
					$this->params->get('ho_resultscounter', '') == '1',
					$this->params->get('cl_resultscounter', ''),
					$this->pageNav->getResultsCounter()
				);
			else
				$replacement = $this->ph_resultscounter->get_orig($this->params->get('cl_no_resultscounter', ''));

			$this->content = str_replace($this->ph_resultscounter->key, $replacement, $this->content);
		}

		foreach ($this->ph_all as $p)
			if (!$p->handled)
				$this->content = str_replace($p->key, $p->get_orig(), $this->content);

		echo $this->content;
	}

}

$engine = new PhotoSpotViewerCustomDesignDisplay();

?>