<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */

class PhotoSpotViewerOneAdmin extends PhotoSpotViewerAdmin {

	function edit() {
		$load_data = true;

		$warnings = array();

		if (JRequest::getCmd('hfrm_viewer_edit', '', 'POST') != '') {
			$load_data = false;
			$v_thumb_width = trim($this->get('thumb_width', ''));
			$v_thumb_height = trim($this->get('thumb_height', ''));
			$v_titles = trim($this->get('titles', ''));
			$v_css_file = trim($this->get('css_file', ''));
			$v_open = $this->get('open', '');

			if ($this->page_refreshed) {
				// ignore page refreshes
			}
			else if (JRequest::getCmd('btn_cancel', '', 'POST') != '') {
				// form cancelled
				$load_data = true;
			}
			else {
				// form submitted successfully

				$error_msg = '';

				if ($v_thumb_width != '' && !ctype_digit($v_thumb_width))
					$error_msg = JText::_('The value in the thumbnail width is not a valid number');
				else if ($v_thumb_height != '' && !ctype_digit($v_thumb_height))
					$error_msg = JText::_('The value in the thumbnail height is not a valid number');

				if ($error_msg == '') {
					$this->data_set('thumb_width', $v_thumb_width);
					$this->data_set('thumb_height', $v_thumb_height);
					$this->data_set('titles', $v_titles);
					$this->data_set('css_file', $v_css_file);
					$this->data_set('open', $v_open);
					$this->save();

					global $mainframe;
					$mainframe->enqueueMessage(JText::_('Viewer updated successfully'));
				}
				else {
					JError::raiseWarning($error_msg, $error_msg);
				}
			}
		}

		if ($load_data) {
			$v_thumb_width = $this->data_get('thumb_width', '');
			$v_thumb_height = $this->data_get('thumb_height', '');
			$v_titles = $this->data_get('titles', '');
			$v_css_file = $this->data_get('css_file', '');
			$v_open = $this->data_get('open', '');
		}

		echo '
<form name="frm_viewer" method="post" action="index.php">
	<input type="hidden" name="hfrm_viewer_edit" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="' . htmlspecialchars(JRequest::getCmd('id')) . '" />

	<input type="submit" name="dmsub" style="display:none" />

	<table cellspacing="10">
		<tr>
			<td>' . JText::_('Open Method') . '</td>
			<td><select name="open">
				<option value="lightbox"' . ($v_open == 'lightbox' ? ' selected="selected"' : '') . '>' . JText::_('Lightbox') . '</option>
				<option value="popup"' . ($v_open == 'popup' ? ' selected="selected"' : '') . '>' . JText::_('Open image in popup window') . '</option>
				<option value="link"' . ($v_open == 'link' ? ' selected="selected"' : '') . '>' . JText::_('Open link') . '</option>
				<option value="linkpopup"' . ($v_open == 'linkpopup' ? ' selected="selected"' : '') . '>' . JText::_('Open link in popup window') . '</option>
				<option value="thumbnails"' . ($v_open == 'thumbnails' ? ' selected="selected"' : '') . '>' . JText::_('Do not open') . '</option>
			</select></td>
		</tr>
		<tr>
			<td>' . JText::_('Titles &amp; Links') . '</td>
			<td><select name="titles">
				<option value="show"' . ($v_titles == 'show' ? ' selected="selected"' : '') . '>' . JText::_('Show title as text') . '</option>
				<option value="link"' . ($v_titles == 'link' ? ' selected="selected"' : '') . '>' . JText::_('Show title as link') . '</option>
				<option value="linkpopup"' . ($v_titles == 'linkpopup' ? ' selected="selected"' : '') . '>' . JText::_('Show title as link and open in popup window') . '</option>
				<option value="no"' . ($v_titles == 'no' ? ' selected="selected"' : '') . '>' . JText::_('Do not show title') . '</option>
			</select></td>
		</tr>
		<tr>
			<td>' . JText::_('Thumbnail Width') . '</td>
			<td>
				<input type="text" name="thumb_width" value="' . htmlspecialchars($v_thumb_width) . '" size="5" />
			</td>
		</tr>
		<tr>
			<td>' . JText::_('Thumbnail Height') . '</td>
			<td>
				<input type="text" name="thumb_height" value="' . htmlspecialchars($v_thumb_height) . '" size="5" />
			</td>
		</tr>
		<tr>
			<td>' . JText::_('CSS File') . '</td>
			<td><input type="text" name="css_file" value="' . htmlspecialchars($v_css_file) . '" /></td>
		</tr>
	</table>

	<div>
		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		&nbsp; <input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</div>
</form>
';
	}

}

$engine = new PhotoSpotViewerOneAdmin();

?>