<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */

class PhotoSpotViewerOneDisplay extends PhotoSpotViewerDisplay {

	function init() {
		$this->limit = 1;
		$this->limitstart = (int) JRequest::getCmd('limitstart');

		return '';
	}

	function render($ds) {
		if (empty($ds->items)) {
			echo JText::_('Gallery has no images');
			return;
		}

		$css_file = trim($this->params->get('css_file', ''));
		if ($css_file != '') {
			$document =& JFactory::getDocument();
			$document->addStyleSheet($css_file);
		}

		$open_method = $this->params->get('open', '');
		$lightbox_group_name = 'photospot';

		$thumb_width = (int) $this->params->get('thumb_width', 0);
		$thumb_height = (int) $this->params->get('thumb_height', 0);

		$titles = $this->params->get('titles', '');

		$item = $ds->items[0];

		$title = htmlspecialchars($item->get_title());
		$title_a = $title == '' ? '' : ' title="' . $title . '"';

		$item->get_thumb_size($thumb_width, $thumb_height, $thumb, $width, $height);

		$a_open = '';
		$a_close = '';

		switch ($open_method) {
			case 'popup':
				$str = '';

				if ($item->img_width > 0)
					$str .= ',width=' . $item->img_width;

				if ($item->img_height > 0)
					$str .= ',height=' . $item->img_height;


				$a_open = '<a href="javascript:void(0)" onclick="window.open(\'' . $item->img_url . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes' . $str . '\')"' . $title_a . '>';
				$a_close = '</a>';
				break;

			case 'link':
				if (!empty($item->link)) {
					$a_open = '<a href="' . $item->link . '"' . $title_a . '>';
					$a_close = '</a>';
				}
				break;

			case 'linkpopup':
				if (!empty($item->link)) {
					$a_open = '<a href="javascript:void(0)" onclick="window.open(\'' . $item->link . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=700,height=600\')"' . $title_a . '>';
					$a_close = '</a>';
				}
				break;

			case 'thumbnails':
				break;

			case 'lightbox':
			default:
				$this->enable_lightbox();
				$a_open = '<a href="' . $item->img_url . '" rel="lightbox[' . $lightbox_group_name . ']"' . $title_a . '>';
				$a_close = '</a>';
		}

		if ($title != '') {
			switch($titles) {
				case 'link':
					if (!empty($item->link))
						$title = '<a href="' . $item->link . '"' . $title_a . '>' . $title . '</a>';
					break;

				case 'linkpopup':
					if (!empty($item->link))
						$title = '<a href="javascript:void(0)" onclick="window.open(\'' . $item->link . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=700,height=600\')"' . $title_a . '>' . $title . '</a>';
					break;

				case 'no':
					$title = '';
					break;

				case 'show':
				default:
			}
		}

		$str = '';

		if ($width > 0)
			$str .= ' width="' . $width . '"';

		if ($height > 0)
			$str .= ' height="' . $height . '"';

		echo '
<div class="ps_image">
	<div class="image">' . $a_open . '<img src="' . $thumb . '"' . $str . ' alt="' . $title . '" border="0" />' . $a_close . '</div>
';
		if ($title != '')
			echo
'	<div class="title">' . $title . '</div>
';

echo '
</div>
';
	}

}

$engine = new PhotoSpotViewerOneDisplay();

?>