<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


class PhotoSpotViewerTableDisplay extends PhotoSpotViewerDisplay {

	function init() {
		$this->max_cols = (int) $this->params->get('max_cols', 0);
		if ($this->max_cols == 0)
			$this->max_cols = 3;

		$this->max_rows = (int) $this->params->get('max_rows', 0);

		$this->limit = $this->max_cols * $this->max_rows;
		$this->limitstart = (int) JRequest::getCmd('limitstart');

		return '';
	}

	function render($ds) {
		if (empty($ds->items)) {
			echo JText::_('Gallery has no images');
			return;
		}

		$css_file = trim($this->params->get('css_file', ''));
		if ($css_file != '') {
			$document =& JFactory::getDocument();
			$document->addStyleSheet($css_file);
		}

		$open_method = $this->params->get('open', '');
		$lightbox_group_name = 'photospot';

		$thumb_width = (int) $this->params->get('thumb_width', 0);
		$thumb_height = (int) $this->params->get('thumb_height', 0);

		echo '
<div class="ps_table_viewer">
	<table cellspacing="10" align="center" class="content">
';

		$titles = $this->params->get('titles', '');

		$i = -1;
		while (isset($ds->items[$i + 1])) {
			echo
'		<tr>
';

			for ($col = 1; $col <= $this->max_cols; $col++) {
				$i++;
				if (isset($ds->items[$i])) {
					$title = htmlspecialchars($ds->items[$i]->get_title());
					$title_a = $title == '' ? '' : ' title="' . $title . '"';

					$ds->items[$i]->get_thumb_size($thumb_width, $thumb_height, $thumb, $width, $height);

					$a_open = '';
					$a_close = '';

					switch ($open_method) {
						case 'popup':
							$str = '';

							if ($ds->items[$i]->img_width > 0)
								$str .= ',width=' . $ds->items[$i]->img_width;

							if ($ds->items[$i]->img_height > 0)
								$str .= ',height=' . $ds->items[$i]->img_height;


							$a_open = '<a href="javascript:void(0)" onclick="window.open(\'' . $ds->items[$i]->img_url . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes' . $str . '\')"' . $title_a . '>';
							$a_close = '</a>';
							break;

						case 'link':
							if (!empty($ds->items[$i]->link)) {
								$a_open = '<a href="' . $ds->items[$i]->link . '"' . $title_a . '>';
								$a_close = '</a>';
							}
							break;

						case 'linkpopup':
							if (!empty($ds->items[$i]->link)) {
								$a_open = '<a href="javascript:void(0)" onclick="window.open(\'' . $ds->items[$i]->link . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=700,height=600\')"' . $title_a . '>';
								$a_close = '</a>';
							}
							break;

						case 'thumbnails':
							break;

						case 'lightbox':
						default:
							$this->enable_lightbox();
							$a_open = '<a href="' . $ds->items[$i]->img_url . '" rel="lightbox[' . $lightbox_group_name . ']"' . $title_a . '>';
							$a_close = '</a>';
					}

					$str = '';

					if ($width > 0)
						$str .= ' width="' . $width . '"';

					if ($height > 0)
						$str .= ' height="' . $height . '"';

					echo
'			<td class="ps_cell">
';

					if ($thumb == '')
						echo
'				&nbsp;
';
					else
						echo
'				<div class="image">' . $a_open . '<img src="' . $thumb . '"' . $str . ' alt="' . $title . '" border="0" />' . $a_close . '</div>
';

					if ($title != '') {
						switch($titles) {
							case 'link':
								if (!empty($ds->items[$i]->link))
									$title = '<a href="' . $ds->items[$i]->link . '"' . $title_a . '>' . $title . '</a>';
								break;

							case 'linkpopup':
								if (!empty($ds->items[$i]->link))
									$title = '<a href="javascript:void(0)" onclick="window.open(\'' . $ds->items[$i]->link . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=700,height=600\')"' . $title_a . '>' . $title . '</a>';
								break;

							case 'no':
								$title = '';
								break;

							case 'show':
							default:
						}
					}

					if ($title != '')
						echo
'				<div class="title">' . $title . '</div>
';

					echo
			'</td>
';
				}
				else {
					echo
'			<td>&nbsp;</td>
';
				}
			}

			echo
'		</tr>
';
		}

		echo
'	</table>
';

		if ($this->params->get('pages', '') == '1' && $this->max_rows > 0 && $ds->items_count > $this->limit) {
			jimport('joomla.html.pagination');
			$pageNav = new JPagination($ds->items_count, $this->limitstart, $this->limit);

			echo '
	<div class="pages">
' . $pageNav->getPagesLinks() . '
	</div>
';
		}

		echo '
</div>
';
	
	}

}

$engine = new PhotoSpotViewerTableDisplay();

?>