<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


// no direct access
defined('_JEXEC') or die('Restricted access');


require_once(dirname(__FILE__) . '/gallery.shared.php');

$v_name = $gallery->name;
$v_access = $gallery->access;
$v_published = !empty($gallery->published);

$gallery_params = new JParameter($gallery->params);
$v_datasource_perm = $gallery_params->get('datasource_permissions', '');
$v_viewer_perm = $gallery_params->get('viewer_permissions', '');

if ($page_refreshed || JRequest::getCmd('btn_cancel') != '' ) {
	// ignore
}
else if (JRequest::getCmd('hfrm_general') != '') {
	// handle gallery name change

	$v_name = trim(JRequest::getVar('name', '', 'POST', 'none', 3));
	$v_access = trim(JRequest::getVar('access', '', 'POST', 'none', 3));
	$v_published = JRequest::getVar('published', '', 'POST', 'none', 3) == '1';

	if ($v_name == '') {
		$v_name = $gallery->name;
		$v_access = $gallery->access;
		$v_published = !empty($gallery->published);
	}
	else {
		$error_msg = '';

		$db =& JFactory::getDBO();
		$db->setQuery("SELECT id FROM #__photospot_galleries WHERE name = " . $db->Quote($v_name) . " AND id != " . $id);
		if ($db->loadObject() !== null)
			$error_msg = JText::_('Another gallery with the same name already exists');

		if ($error_msg == '' && !ctype_digit($v_access))
			$error_msg = JText::_('Invalid access level');

		if ($error_msg == '') {
			$db->setQuery("UPDATE #__photospot_galleries SET name = " . $db->Quote($v_name) . ", access = $v_access, published = " . ($v_published ? '1' : '0') . " WHERE id = $id");
			$db->query();

			global $mainframe;
			$mainframe->enqueueMessage(JText::_('Gallery\'s general details updated successfully'));
		}
		else {
			JError::raiseWarning($error_msg, $error_msg);
		}
	}
}
else if (JRequest::getCmd('hfrm_datasource_url_permissions') != '') {
	// handle url permissions change for the data source

	$v_datasource_perm = trim(JRequest::getVar('sel_permissions', '', 'POST', 'none', 3));
	$gallery_params->set('datasource_permissions', $v_datasource_perm);

	$db =& JFactory::getDBO();
	$db->setQuery("UPDATE #__photospot_galleries SET params = " . $db->Quote($gallery_params->toString()) . " WHERE id = $id");
	$db->query();

	global $mainframe;
	$mainframe->enqueueMessage(JText::_('Data source URL permissions updated successfully'));
}
else if (JRequest::getCmd('hfrm_viewer_url_permissions') != '') {
	// handle url permissions change for the viewer

	$v_viewer_perm = trim(JRequest::getVar('sel_permissions', '', 'POST', 'none', 3));
	$gallery_params->set('viewer_permissions', $v_viewer_perm);

	$db =& JFactory::getDBO();
	$db->setQuery("UPDATE #__photospot_galleries SET params = " . $db->Quote($gallery_params->toString()) . " WHERE id = $id");
	$db->query();

	global $mainframe;
	$mainframe->enqueueMessage(JText::_('Viewer URL permissions updated successfully'));
}


$mainframe->set('JComponentTitle', $com_title_start . ' - ' . JText::_('Gallery') . ': ' . htmlspecialchars($v_name) . '</div>');

function echo_help($directory) {
	static $locale = null;
	if ($locale === null) {
		$conf =& JFactory::getConfig();
		$locale = $conf->getValue('config.language');
	}

	if (substr($directory, 0, strlen(JPATH_ADMINISTRATOR)) == JPATH_ADMINISTRATOR)
		$url_dir = substr($directory, strlen(JPATH_ADMINISTRATOR) + 1);
	else
		$url_dir = '..' . substr($directory, strlen(JPATH_SITE));

	if (file_exists($directory . 'help/' . $locale . '/index.html'))
		$path = $url_dir . 'help/' . $locale . '/index.html';

	if (!isset($path) && file_exists($directory . 'help/en-GB/index.html'))
		$path = $url_dir . 'help/en-GB/index.html';

	$path = str_replace('\\', '/', $path);

	if (isset($path)) {
		echo '
	<div class="ps_help">
		<div class="ps_help_title">
			<h3>' . JText::_('Help') . '</h3>
			[ <a href="javascript:void(0)" onclick="window.open(\'' . $path . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=600,height=500\')">' . JText::_('Open in new window') . '</a> ]
		</div>
		<div class="ps_help_content"><iframe src="' . $path . '" frameborder="0" width="100%"></iframe></div>
	</div>
';
	}
	else {
		echo '
	<div class="ps_help">
		' . JText::_('Help is not available') . '
	</div>
';
	}
}


// output form

$group_start = '
<div class="group_tc"><div class="group_tl"><div class="group_tr">%s</div></div></div>
<div class="group_content">
';

$group_end = '
</div>
<div class="group_end"></div>
';

printf($group_start, JText::_('General'));
echo '
	<form name="frm_general" class="general" method="post" action="index.php">
		<input type="hidden" name="hfrm_general" value="' . microtime() . '" />
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
		<input type="hidden" name="id" value="' . $id . '" />

		<input type="submit" name="dmsub" style="display:none" />

		' . JText::_('Name') . ' <input type="text" name="name" value="' . htmlspecialchars($v_name) . '" />

		&nbsp; - &nbsp; ' . JText::_('ID') . ': ' . $id . '

		&nbsp; - &nbsp; <input type="checkbox" name="published" id="published" value="1"' . ($v_published ? ' checked="checked"' : '') . ' /> <label for="published">' . JText::_('Published') . '</label>

		&nbsp; - &nbsp; ' . JText::_('Access Level') . '
		<select name="access">
			<option value="0"' . ($v_access == '0' ? ' selected="selected"' : '') . '>' . JText::_('Public') . '</option>
			<option value="1"' . ($v_access == '1' ? ' selected="selected"' : '') . '>' . JText::_('Registered') . '</option>
			<option value="2"' . ($v_access == '2' ? ' selected="selected"' : '') . '>' . JText::_('Special') . '</option>
		</select>

		&nbsp; - &nbsp; <input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		<input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</form>

	<span class="splitter">|</span>

	<form name="frm_delete" class="general" method="post" action="index.php">
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="gallery.delete" />
		<input type="hidden" name="id" value="' . $id . '" />

		<input type="submit" name="submit" value="' . JText::_('Delete gallery') . '" />
	</form>
' . $group_end;

if (empty($datasource_info)) {
	printf($group_start, JText::_('Data Source'));
	echo '
	<form class="element_type" name="frm_datasource_type" method="post" action="index.php">
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="gallery.change_datasource" />
		<input type="hidden" name="id" value="' . $id . '" />

		<div>' . JText::_('Datasource deleted') . '</div>
		<input type="submit" name="submit" value="' . JText::_('Change datasource') . '" />
	</form>
' . $group_end;
}
else {
	printf($group_start, JText::_('Data Source'));
	echo '
	<form class="element_type" name="frm_datasource_type" method="post" action="index.php">
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="gallery.change_datasource" />
		<input type="hidden" name="id" value="' . $id . '" />

		' . JText::_('Type') . ': <span class="type">' . ($datasource_info->title != '' ? $datasource_info->title : $datasource_info->code_name) . '</span>
		<input type="submit" name="submit" value="' . JText::_('Change') . '" />
	</form>

	<span class="splitter">|</span>

	<form class="element_type" name="frm_datasource_url_permissions" method="post" action="index.php">
		<input type="hidden" name="hfrm_datasource_url_permissions" value="' . microtime() . '" />
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
		<input type="hidden" name="id" value="' . $id . '" />

		<input type="submit" name="dmsub" style="display:none" />

		' . JText::_('URL Permissions') . '
		&nbsp; <select name="sel_permissions">
			<option value="locked"' . ($v_datasource_perm == 'locked' ? ' selected="selected"' : '') . '>' . JText::_('No changes allowed') . '</option>
			<option value="allow_params"' . ($v_datasource_perm == 'allow_params' ? ' selected="selected"' : '') . '>' . JText::_('URL can set parameters') . '</option>
			<option value="allow_all"' . ($v_datasource_perm == 'allow_all' ? ' selected="selected"' : '') . '>' . JText::_('URL can change all') . '</option>
		</select>

		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		<input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</form>

	<hr/>

	<table width="100%">
		<tr>
			<td valign="top" width="48%">
';

	require($datasource_info->directory . 'admin.php');
	$engine->id = $id;
	$engine->data_load($gallery->datasource_params);
	$engine->page_refreshed = $page_refreshed;
	$engine->edit();

	echo '
			</td>
			<td width="4%">&nbsp;</td>
			<td valign="top" width="48%">
';

	echo_help($datasource_info->directory);

	echo '
			</td>
		</tr>
	</table>
' . $group_end;
}

if (empty($viewer_info)) {
	printf($group_start, JText::_('Viewer'));
	echo '
	<form class="element_type" name="frm_viewer_type" method="post" action="index.php">
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="gallery.change_viewer" />
		<input type="hidden" name="id" value="' . $id . '" />

		<div>' . JText::_('Viewer deleted') . '</div>
		<input type="submit" name="submit" value="' . JText::_('Change viewer') . '" />
	</form>
' . $group_end;
}
else {
	printf($group_start, JText::_('Viewer'));
	echo '
	<form class="element_type" name="frm_viewer_type" method="post" action="index.php">
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="gallery.change_viewer" />
		<input type="hidden" name="id" value="' . $id . '" />

		' . JText::_('Type') . ': <span class="type">' . ($viewer_info->title != '' ? $viewer_info->title : $viewer_info->code_name) . '</span>
		<input type="submit" name="submit" value="' . JText::_('Change') . '" />
	</form>

	<span class="splitter">|</span>

	<form class="element_type" name="frm_viewer_url_permissions" method="post" action="index.php">
		<input type="hidden" name="hfrm_viewer_url_permissions" value="' . microtime() . '" />
		<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
		<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
		<input type="hidden" name="id" value="' . $id . '" />

		<input type="submit" name="dmsub" style="display:none" />

		' . JText::_('URL Permissions') . '
		&nbsp; <select name="sel_permissions">
			<option value="locked"' . ($v_viewer_perm == 'locked' ? ' selected="selected"' : '') . '>' . JText::_('No changes allowed') . '</option>
			<option value="allow_params"' . ($v_viewer_perm == 'allow_params' ? ' selected="selected"' : '') . '>' . JText::_('URL can set parameters') . '</option>
			<option value="allow_all"' . ($v_viewer_perm == 'allow_all' ? ' selected="selected"' : '') . '>' . JText::_('URL can change all') . '</option>
		</select>

		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
		<input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
	</form>

	<hr/>

	<table width="100%">
		<tr>
			<td valign="top" width="48%">
';

	require($viewer_info->directory . 'admin.php');
	$engine->id = $id;
	$engine->data_load($gallery->viewer_params);
	$engine->page_refreshed = $page_refreshed;
	$engine->edit();

	echo '
			</td>
			<td width="4%">&nbsp;</td>
			<td valign="top" width="48%">
';

	echo_help($viewer_info->directory);

	echo '
			</td>
		</tr>
	</table>
' . $group_end;
}

?>