<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


// no direct access
defined('_JEXEC') or die('Restricted access');

$mainframe->set('JComponentTitle', $com_title_start . ' - ' . JText::_('Gallery List') . '</div>');

$bar =& JToolBar::getInstance('toolbar');
$bar->appendButton('Link', 'ps_gallery_new', JText::_('New Gallery'), 'index.php?option=' . JRequest::getCmd('option') . '&task=gallery.new');
$bar->appendButton('Link', 'ps_settings', JText::_('Settings'), 'index.php?option=' . JRequest::getCmd('option') . '&task=settings');
$bar->appendButton('Link', 'ps_help', JText::_('Help'), 'index.php?option=' . JRequest::getCmd('option') . '&task=help');

$db =& JFactory::getDBO();


if (JRequest::getCmd('hfrm_publish') != '' && !$page_refreshed) {
	$id = (int) JRequest::getCmd('id');
	if ($id > 0) {
		$db->setQuery("SELECT published FROM #__photospot_galleries WHERE id = $id");
		$published = (bool) $db->loadResult();
		$db->setQuery("UPDATE #__photospot_galleries SET published = " . ($published ? '0' : '1') . " WHERE id = $id");
		$db->query();
	}
}


$db->setQuery("SELECT * FROM #__photospot_galleries ORDER BY id");
$res = $db->loadObjectList();

if (empty($res)) {
	echo '<div class="empty_list">' . JText::_('There are no available galleries') . '</div>';
}
else {
	echo '
<div align="center">

<div id="logo_list"><img src="components/com_photospot/images/logo_list.png" alt="" /></div>

<table align="center"><tr><td>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title">' . JText::_('ID') . '</th>
			<th class="title">' . JText::_('Name') . '</th>
			<th class="title">' . JText::_('Published') . '</th>
			<th class="title">' . JText::_('Access Level') . '</th>
			<th class="title">' . JText::_('Data Source') . '</th>
			<th class="title">' . JText::_('Viewer') . '</th>
		</tr>
	</thead>
	<tbody>
';

	require(dirname(__FILE__) . '/../utils.php');
	$utils =& PhotoSpotUtils::get_instance();

	$datasource_lib = array();
	$viewer_lib = array();
	foreach ($res as $rec) {
		if ($rec->datasource != '' && !isset($datasource_lib[$rec->datasource])) {
			$datasource = $utils->get_datasource_info($rec->datasource, true);
			$datasource_lib[$rec->datasource] = $datasource === false || $datasource->title == '' ? $rec->datasource : $datasource->title;
		}

		if ($rec->viewer != '' && !isset($viewer_lib[$rec->viewer])) {
			$viewer = $utils->get_viewer_info($rec->viewer, true);
			$viewer_lib[$rec->viewer] = $viewer === false || $viewer->title == '' ? $rec->viewer : $viewer->title;
		}

		if ($rec->access == 0)
			$access_str = '<span style="color:green">' . JText::_('Public') . '</span>';
		else if ($rec->access == 1)
			$access_str = '<span style="color:red">' . JText::_('Registered') . '</span>';
		else
			$access_str = JText::_('Special');

		echo '
		<tr>
			<td>' . $rec->id . '</td>
			<td><a href="index.php?option=com_photospot&amp;task=gallery.edit&amp;id=' . $rec->id . '">' . htmlspecialchars($rec->name) . '</a></td>
			<td align="center"><img class="gallery_image" src="images/' . ($rec->published ? 'tick.png' : 'publish_x.png') . '" id="' . $rec->id . '"></td>
			<td align="center">' . $access_str . '</td>
			<td>' . htmlspecialchars($datasource_lib[$rec->datasource]) . '</td>
			<td>' . htmlspecialchars($viewer_lib[$rec->viewer]) . '</td>
		</tr>
';
	}

	echo '
	</tbody>
</table>
</td></tr></table>
</div>

<form name="frm_publish" method="post" action="index.php">
	<input type="hidden" name="hfrm_publish" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="0" />
</form>

<script type="text/javascript">
// <![CDATA[
var images = document.getElementsByTagName("img");
for (var k in images)
	if (images[k].className && images[k].className == "gallery_image")
		images[k].onclick = function () {
			document.forms.frm_publish.id.value = this.getAttribute("id");
			document.forms.frm_publish.submit();
		}
// ]]>
</script>

';
}

?>