<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require(dirname(__FILE__) . '/../utils.php');
$utils =& PhotoSpotUtils::get_instance();

if (JRequest::getCmd('hfrm_new_gallery', '', 'POST') != '') {
	$v_name = trim(JRequest::getVar('name', '', 'POST', 'none', 3));
	$v_datasource = JRequest::getVar('datasource', '', 'POST', 'none', 3);
	$v_viewer = JRequest::getVar('viewer', '', 'POST', 'none', 3);

	if ($page_refreshed) {
		// ignore page refreshes
	}
	else if (JRequest::getCmd('btn_cancel', '', 'POST') != '') {
		// form cancelled

		$mainframe->redirect('index.php?option=' . JRequest::getCmd('option') . '&task=gallery.list');
	}
	else {
		// form submitted successfully

		$error_msg = '';

		if ($v_name == '')
			$error_msg = JText::_('The name of the new gallery is not set');
		else if ($v_datasource == '')
			$error_msg = JText::_('The data source of the new gallery is not set');
		else if ($v_viewer == '')
			$error_msg = JText::_('The viewer of the new gallery is not set');

		if ($error_msg == '') {
			$db =& JFactory::getDBO();
			$db->setQuery("SELECT * FROM #__photospot_galleries WHERE name = " . $db->Quote($v_name));
			if ($db->loadObject() !== null)
				$error_msg = JText::_('Another gallery with the same name already exists');
		}

		if ($error_msg == '') {
			$db->setQuery("INSERT INTO #__photospot_galleries (name, published, access, datasource, viewer) VALUES (" . $db->Quote($v_name) . ", 1, 0, " . $db->Quote($v_datasource) . ", " . $db->Quote($v_viewer) . ")");
			$db->query();
			$id = $db->insertid();

			require_once(dirname(__FILE__) . '/../classes.admin.php');

			$datasource_info = $utils->get_datasource_info($v_datasource, false);
			require($datasource_info->directory . 'admin.php');
			$engine->id = $id;
			$engine->setup();

			$viewer_info = $utils->get_viewer_info($v_viewer, false);
			require($viewer_info->directory . 'admin.php');
			$engine->id = $id;
			$engine->setup();

			$mainframe->redirect('index.php?option=' . JRequest::getCmd('option') . '&task=gallery.edit&id=' . $id);
		}
		else {
			JError::raiseWarning($error_msg, $error_msg);
		}
	}
}
else {
	$v_name = '';
	$v_datasource = '';
	$v_viewer = '';
}

$mainframe->set('JComponentTitle', $com_title_start . ' - ' . JText::_('Create new gallery') . '</div>');

$bar =& JToolBar::getInstance('toolbar');
$bar->appendButton('Link', 'ps_gallery_list', JText::_('Gallery List'), 'index.php?option=' . JRequest::getCmd('option') . '&task=gallery.list');
$bar->appendButton('Link', 'ps_help', JText::_('Help'), 'index.php?option=' . JRequest::getCmd('option') . '&task=help');

$datasource_list = $utils->get_datasource_list();
$viewer_list = $utils->get_viewer_list();

$document =& JFactory::getDocument();
$document->addScriptDeclaration('
document.sel_datasource = "";
document.sel_viewer = "";

function onchange_datasource(value) {
	if (document.sel_datasource != "")
		document.getElementById(document.sel_datasource).style.display = "none";

	if (value == "") {
		document.sel_datasource = "";
	}
	else {
		document.sel_datasource = "datasource_info_" + value;
		document.getElementById(document.sel_datasource).style.display = "block";
	}
}

function onchange_viewer(value) {
	if (document.sel_viewer != "")
		document.getElementById(document.sel_viewer).style.display = "none";

	if (value == "") {
		document.sel_viewer = "";
	}
	else {
		document.sel_viewer = "viewer_info_" + value;
		document.getElementById(document.sel_viewer).style.display = "block";
	}
}

');

echo '
<form name="frm" method="post" action="index.php">
	<input type="hidden" name="hfrm_new_gallery" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />

	<table cellspacing="10" align="center">
		<tr>
			<td valign="top">' . JText::_('Name') . '</td>
			<td><input type="text" name="name" value="' . htmlspecialchars($v_name) . '" /></td>
		</tr>
		<tr>
			<td></td>
			<td>
				' . wordwrap(JText::_('FRIENDLY NAME'), 75, '<br/>') . '
			</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Data Source') . '</td>
			<td>
				<select name="datasource" onchange="onchange_datasource(this.value)">
					<option value="">-- ' . JText::_('select one') . ' -- </option>
';

foreach ($datasource_list as $item)
	printf(
'					<option value="%s"%s>%s [%s]</option>
',
		$item->code_name,
		$v_datasource == $item->code_name ? ' selected="selected"' : '',
		$item->title,
		$item->code_name
	);

echo '
				</select>
			</td>
		</tr>
		<tr>
			<td></td>
			<td>
';

foreach ($datasource_list as $item)
	echo '
				<div id="datasource_info_' . $item->code_name . '" style="display:none">
' . wordwrap($item->info['description'], 75, '<br/>') . '
				</div>
';

echo '
			</td>
		</tr>
		<tr>
			<td valign="top">' . JText::_('Viewer') . '</td>
			<td>
				<select name="viewer" onchange="onchange_viewer(this.value)">
					<option value="">-- ' . JText::_('select one') . ' -- </option>
';

foreach ($viewer_list as $item)
	printf(
'					<option value="%s"%s>%s [%s]</option>
',
		$item->code_name,
		$v_viewer == $item->code_name ? ' selected="selected"' : '',
		$item->title,
		$item->code_name
	);

echo '
				</select>
			</td>
		</tr>
		<tr>
			<td></td>
			<td>
';

foreach ($viewer_list as $item)
	echo '
				<div id="viewer_info_' . $item->code_name . '" style="display:none">
' . wordwrap($item->info['description'], 75, '<br/>') . '
				</div>
';

echo '
			</td>
		</tr>
		<tr>
			<td></td>
			<td>
				<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
				&nbsp; <input type="submit" name="btn_create" value="' . JText::_('Create') . '" />
			</td>
		</tr>
	</table>
</form>

<script type="text/javascript">
// <![CDATA[
';

if ($v_datasource != '')
	echo 'onchange_datasource("' . $v_datasource . '");' . "\n";

if ($v_viewer != '')
	echo 'onchange_viewer("' . $v_viewer . '");' . "\n";

echo '
// ]]>
</script>

';

?>