<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */


// no direct access
defined('_JEXEC') or die('Restricted access');

$mainframe->set('JComponentTitle', $com_title_start . ' - ' . JText::_('Help') . '</div>');

$bar =& JToolBar::getInstance('toolbar');
$bar->appendButton('Link', 'ps_gallery_list', JText::_('Gallery List'), 'index.php?option=' . JRequest::getCmd('option') . '&task=gallery.list');
$bar->appendButton('Link', 'ps_settings', JText::_('Settings'), 'index.php?option=' . JRequest::getCmd('option') . '&task=settings');

JHTML::_('behavior.tooltip');
jimport('joomla.html.pane');
$pane = &JPane::getInstance('sliders', array('allowAllClose' => true));

require(dirname(__FILE__) . '/../utils.php');
$utils =& PhotoSpotUtils::get_instance();

$datasource_list = $utils->get_datasource_list();
$viewer_list = $utils->get_viewer_list();

$fmt = '
	<div class="panel">
		<h3 class="jpane-toggler title"><span>%s</span></h3>
		<div class="jpane-slider content"><div class="jpane-content">
<span class="type_title">' . JText::_('Title') . '</span>: %s
<br/><span class="type_title">' . JText::_('Code name') . '</span>: %s
<br/><span class="type_title">' . JText::_('Type') . '</span>: %s
<br/><span class="type_title">' . JText::_('Directory') . '</span>: %s
<br/><span class="type_title">' . JText::_('Author') . '</span>: %s
<br/><span class="type_title">' . JText::_('Author\'s Email') . '</span>: %s
<br/><span class="type_title">' . JText::_('Author\'s Website') . '</span>: %s
<br/><span class="type_title">' . JText::_('Copyright') . '</span>: %s
<br/><span class="type_title">' . JText::_('License') . '</span>: %s
<br/>
<br/><span class="type_title">' . JText::_('Description') . '</span>:
<br/>%s
		</div></div>
	</div>
';

$version = preg_match('~<version>([^<]+)</version>~', file_get_contents(dirname(__FILE__) . '/../com_photospot.xml'), $m) ? $m[1] : '?';

$conf =& JFactory::getConfig();
$locale = $conf->getValue('config.language');
if (file_exists(dirname(__FILE__) . '/../help/' . $locale . '/index.html'))
	$path = 'components/com_photospot/help/' . $locale . '/index.html';
else
	$path = 'components/com_photospot/help/en-GB/index.html';

echo '
<table width="100%" cellspacing="10">
	<tr>
		<td valign="top">
			<div class="ps_help_title">
				<h3>' . JText::_('About Photo Spot') . '</h3>
				[ <a href="javascript:void(0)" onclick="window.open(\'' . $path . '\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=600,height=500\')">' . JText::_('Open in new window') . '</a> ]
			</div>

			<div class="ps_help_content"><iframe src="' . $path . '" frameborder="0" width="100%" height="200"></iframe></div>
		</td>
		<td width="10">&nbsp;</td>
		<td valign="top" width="210" nowrap="nowrap">
			<div class="ps_help_title"><h3>Photo Spot v' . $version . '</h3></div>
			<p>
				<span class="type_title">License</span>: GNU / GPLv2
				<br/><span class="type_title">Copyright</span>: (C)2009 Creative Pulse
				<br/><span class="type_title">Website</span>: <a href="http://www.creativepulse.eu">http://www.creativepulse.eu</a>
			</p>
			<p>
				Programming by Alex Stylianos,
				<br/>Creative Pulse Ltd, Greece.
				<br/><a href="http://www.creativepulse.eu">http://www.creativepulse.eu</a>
			</p>
			<p>
				Graphics by Panos Gazepidis,
				<br/>Mediagrafix, Greece.
				<br/><a href="http://www.mediagrafix.gr">http://www.mediagrafix.gr</a>
			</p>
			<p>
				You can find more themes and
				<br/>customizations at Bonus Themes
				<br/><a href="http://www.bonusthemes.com">http://www.bonusthemes.com</a>
			</p>
		</td>
	</tr>
</table>

&nbsp;

<table width="100%" cellspacing="0">
	<tr>
		<td valign="top" width="50%">
			<fieldset class="adminform">
				<legend>' . JText::_('Available Data Sources') . '</legend>

				' . JText::_('Click on the following tabs to view details') . ':
				<br/>&nbsp;

				<div class="pane-sliders">
';

foreach ($datasource_list as $item)
	printf(
		$fmt,
		$item->title != '' ? $item->title : $item->code_name,
		$item->title,
		$item->code_name,
		$item->type == $item->TYPE_INTERNAL ? JText::_('Core Plugin') : JText::_('External Plugin'),
		substr($item->directory, strlen(JPATH_SITE), -1),
		$item->info['author'],
		$item->info['authorEmail'],
		$item->info['authorUrl'],
		$item->info['copyright'],
		$item->info['license'],
		$item->info['description']
	);

echo '
				</div>
			</fieldset>
		</td>
		<td valign="top" width="50%">
			<fieldset class="adminform">
				<legend>' . JText::_('Available Viewers') . '</legend>

				' . JText::_('Click on the following tabs to view details') . ':
				<br/>&nbsp;

				<div class="pane-sliders">
';

foreach ($viewer_list as $item)
	printf(
		$fmt,
		$item->title != '' ? $item->title : $item->code_name,
		$item->title,
		$item->code_name,
		$item->type == $item->TYPE_INTERNAL ? JText::_('Core Plugin') : JText::_('External Plugin'),
		substr($item->directory, strlen(JPATH_SITE), -1),
		$item->info['author'],
		$item->info['authorEmail'],
		$item->info['authorUrl'],
		$item->info['copyright'],
		$item->info['license'],
		$item->info['description']
	);

echo '
				</div>
			</fieldset>
		</td>
	</tr>
</table>

';

?>