<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */

// no direct access
defined('_JEXEC') or die('Restricted access');


if (defined('PHOTOSPOT_FRONT_MAIN'))
	return;
else
	define('PHOTOSPOT_FRONT_MAIN', 1);


function pscom_get_option($key, $default) {
	$db =& JFactory::getDBO();
	$db->setQuery("SELECT `value` FROM #__photospot_misc WHERE `key` = " . $db->Quote($key));
	$result = $db->loadResult();
	return empty($result) ? $default : $result;
}

$gallery = null;

$db =& JFactory::getDBO();
$user =& JFactory::getUser();
$aid = (int) $user->get('aid', 0);

$menus =& JSite::getMenu();
$menu = $menus->getActive();

if ($menu !== null) {
	$menu_params = new JParameter($menu->params);

	// check for access restrictions from the menu item
	$access = $menu_params->get('access', '');
	if ($access != '' && $aid < intval($access)) {
		$error_msg = pscom_get_option('error_msg_unauthorized', 'You are not authorized to access this gallery');
		JError::raiseWarning($error_msg, JText::_($error_msg));
		return;
	}

	// load gallery from the menu parameter gallery id
	$handle = trim($menu_params->get('gid', ''));
	if ($handle != '' && $handle != '0') {
		$db->setQuery("SELECT * FROM #__photospot_galleries WHERE id = " . intval($handle));
		$gallery = $db->loadObject();

		if ($gallery === null) {
			JError::raiseWarning('Gallery not found', JText::_('Gallery not found'));
			return;
		}
	}

	// load gallery from the menu parameter gallery name
	if ($gallery === null) {
		$handle = trim($menu_params->get('gname', ''));
		if ($handle != '') {
			$db->setQuery("SELECT * FROM #__photospot_galleries WHERE name = " . $db->Quote($handle));
			$gallery = $db->loadObject();

			if ($gallery === null) {
				JError::raiseWarning('Gallery not found', JText::_('Gallery not found'));
				return;
			}
		}
	}
 
	if ($gallery === null)
		$gallery_from_url = intval($menu_params->get('gallery_from_url', 0)) == 1;
}
else {
	$menu_params = new JParameter('');
	$gallery_from_url = (bool) pscom_get_option('gallery_from_url', true);
}


// load gallery from the URL variable gid
if ($gallery === null && $gallery_from_url) {
	$handle = trim(JRequest::getCmd('gid'));
	if ($handle != '' && $handle != '0') {
		$db->setQuery("SELECT * FROM #__photospot_galleries WHERE id = " . intval($handle));
		$gallery = $db->loadObject();

		if ($gallery === null) {
			JError::raiseWarning('Gallery not found', JText::_('Gallery not found'));
			return;
		}
	}
}


// load gallery from the URL variable gname
if ($gallery === null && $gallery_from_url) {
	$handle = trim(JRequest::getCmd('gname'));
	if ($handle != '') {
		$db->setQuery("SELECT * FROM #__photospot_galleries WHERE name = " . $db->Quote($handle));
		$gallery = $db->loadObject();

		if ($gallery === null) {
			JError::raiseWarning('Gallery not found', JText::_('Gallery not found'));
			return;
		}
	}
}


// check for gallery availability
if ($gallery !== null && $gallery->published == '0') {
	$error_msg = pscom_get_option('error_msg_unpublished_gallery', 'Gallery is unavailable');
	JError::raiseWarning($error_msg, JText::_($error_msg));
	return;
}


// check for access restrictions from the gallery
if ($gallery !== null && $aid < intval($gallery->access)) {
	$error_msg = pscom_get_option('error_msg_unauthorized', 'You are not authorized to access this gallery');
	JError::raiseWarning($error_msg, JText::_($error_msg));
	return;
}


$datasource_name = '';
$viewer_name = '';
$gds = JRequest::getCmd('gds');
$gvw = JRequest::getCmd('gvw');

$datasource_permissions = '';
$viewer_permissions = '';
if ($gallery !== null) {
	$gallery_params = new JParameter($gallery->params);
	$datasource_permissions = $gallery_params->get('datasource_permissions', '');
	$viewer_permissions = $gallery_params->get('viewer_permissions', '');
}
if ($menu !== null) {
	$p = $menu_params->get('datasource_permissions', '');
	if ($p != '')
		$datasource_permissions = $p;

	$p = $menu_params->get('viewer_permissions', '');
	if ($p != '')
		$viewer_permissions = $p;
}


if ($menu === null && $gds != '' && $gvw != '' && pscom_get_option('allow_unmapped_galleries', false)) {
	// load datasource and viewer from the URL
	$datasource_name = $gds;
	$datasource_permissions = 'allow_all';
	$viewer_name = $gvw;
	$viewer_permissions = 'allow_all';
}
else {
	$menu_datasource_name = $menu === null ? '' : trim($menu_params->get('datasource_name', ''));
	$menu_viewer_name = $menu === null ? '' : trim($menu_params->get('viewer_name', ''));

	if ($gds != '' && $datasource_permissions == 'allow_all')
		$datasource_name = $gds;
	else if ($menu_datasource_name != '')
		$datasource_name = $menu_datasource_name;
	else if ($gallery !== null)
		$datasource_name = $gallery->datasource;

	if ($gvw != '' && $viewer_permissions == 'allow_all')
		$viewer_name = $gvw;
	else if ($menu_viewer_name != '')
		$viewer_name = $menu_viewer_name;
	else if ($gallery !== null)
		$viewer_name = $gallery->viewer;
}

if ($datasource_name == '' || $viewer_name == '') {
	JError::raiseWarning('Missing gallery information', JText::_('Missing gallery information'));
	return;
}

if ($gallery !== null) {
	$datasource_params = new JParameter($gallery->datasource_params);
	$viewer_params = new JParameter($gallery->viewer_params);
}
else {
	$datasource_params = new JParameter('');
	$viewer_params = new JParameter('');
}

if ($menu !== null) {
	$p = new JParameter($menu_params->get('datasource_params', ''));
	$datasource_params->merge($p);

	$p = new JParameter($menu_params->get('viewer_params', ''));
	$viewer_params->merge($p);
}

if ($datasource_permissions == 'allow_params' || $datasource_permissions == 'allow_all')
	foreach ($_GET as $k => $v)
		$datasource_params->set($k, $v);

if ($viewer_permissions == 'allow_params' || $viewer_permissions == 'allow_all')
	foreach ($_GET as $k => $v)
		$viewer_params->set($k, $v);


// run gallery
require(dirname(__FILE__) . '/show_gallery.php');

?>