<?php

/**
 * Photo Spot
 *
 * @package com_photospot_j15
 * @version 1-20100914.0
 */

// no direct access
defined('_JEXEC') or die('Restricted access');


require(JPATH_ADMINISTRATOR . '/components/com_photospot/classes.display.php');

require(JPATH_ADMINISTRATOR . '/components/com_photospot/utils.php');
$utils =& PhotoSpotUtils::get_instance();

$datasource_info = $utils->get_datasource_info($datasource_name);
if ($datasource_info === false) {
	JError::raiseWarning('PhotoSpot data source unavailable', JText::_('The data source is not available'));
	return;
}
$datasource =& $utils->load_display($datasource_info);
if (is_string($datasource)) {
	JError::raiseWarning($datasource, $datasource);
	return;
}

$viewer_info = $utils->get_viewer_info($viewer_name);
if ($viewer_info === false) {
	JError::raiseWarning('PhotoSpot viewer unavailable', JText::_('The viewer is not available'));
	return;
}
$viewer =& $utils->load_display($viewer_info);
if (is_string($viewer)) {
	JError::raiseWarning($viewer, $viewer);
	return;
}

$viewer->params = $viewer_params;
$error_msg = $viewer->init();
if (!empty($error_msg)) {
	JError::raiseWarning($error_msg, $error_msg);
	return;
}

if ($viewer->process_datasource) {
	$datasource->gallery_name = $gallery !== null ? $gallery->name : '';
	$datasource->menu_params = $menu_params;
	$datasource->params = $datasource_params;
	$error_msg = $datasource->init($viewer);
	if (!empty($error_msg)) {
		JError::raiseWarning($error_msg, $error_msg);
		return;
	}
}
else {
	$datasource = null;
}

$error_msg = $viewer->render($datasource);
if (!empty($error_msg))
	JError::raiseWarning($error_msg, $error_msg);

?>